#!/usr/bin/env python
# -*- coding: utf-8 -*-
#-----------------------------------------------------------
# Application :    Noethys, gestion multi-activités
# Site internet :  www.noethys.com
# Auteur:           Ivan LUCAS
# Copyright:       (c) 2010-12 Ivan LUCAS
# Licence:         Licence GNU GPL
#-----------------------------------------------------------



LISTE_CITATIONS = [

(u"Rien de tel pour vous apprendre l'écriture qu'un maître qui ne sait pas lire.", u"Paul Claudel, L'Otage"),
(u"La vocation, c'est d'avoir pour métier sa passion.", u"stendhal"),
(u"Apprenez que tout flatteur Vit aux dépens de celui qui l'écoute.", u"La Fontaine, Le Corbeau et le Renard"),
(u"Le bonheur n'a jamais été le lot de ceux qui s'acharnent.", u"Jean Giraudaux, Électre"),
(u"Choisir la vie, c'est toujours choisir l'avenir. Sans cet élan qui nous porte en avant nous ne serions rien de plus qu'une moisissure à la surface de la terre.", u"Simone de Beauvoir"),
(u"Les médias reflètent ce que disent les gens, les gens reflètent ce que disent les médias. Ne va-t-on jamais se lasser de cet abrutissant jeu de miroirs?", u"Amine Maalouf"),
(u"La vie est courte pour celui qui la compte en années, et longue pour celui qui la compte en secondes.", u"Mikhail Nuaymah"),
(u"Il est permis de mentir aux enfants, lorsque c'est pour leur bien.", u"Marcel Pagnol, La Gloire de mon père"),
(u"Il n'est pas besoin d'espérer pour entreprendre, ni de réussir pour persévérer.", u"Marcel Pagnol, La Gloire de mon Père"),
(u"Il y a beaucoup de gens dont la facilité de parler ne vient que de l'impuissance de se taire.", u"Savinien de Cyrano de Bergerac"),
(u"Quand on croit être heureux, vous savez que cela suffit pour l'être.", u"Madame de La Fayette, Lettres"),
(u"Toutes mes résolutions sont inutiles; je pensais hier tout ce que je pense aujourd'hui et je fais aujourd'hui le contraire de ce que je résolus hier.", u"Madame de La Fayette, La Princesse de Clèves" ),
(u"Nos actes ne sont éphémères qu'en apparence. Leurs répercussions se prolongent parfois pendant des siècles. La vie du présent tisse celle de l'avenir.", u"G. Le Bon, Hier et Demain"),
(u"La grandeur des actions humaines se mesure à l'inspiration qui les fait naître.", u"Louis Pasteur"),
(u"Soyons réalistes, exigeons l'impossible!", u"Ché Guévara"),
(u"Il ne faut jamais lancer contre des adversaires des bruits non fondés, ou leur prêter des intentions, car l'adversaire est, comme quiconque, un hôte de l'esprit.", u"Schweitzer"),
(u"Aucune carte du monde n'est digne d'un regard si le pays de l'utopie n'y figure pas.", u"Oscar Wilde"),
(u"Faites que le rêve dévore votre vie, afin que la vie ne dévore pas votre rêve.", u"Antoine de Saint-Exupéry"),
(u"Les grandes âmes ne sont pas soupçonnées; elles se cachent; ordinairement, il ne paraît qu'un peu d'originalité. Il y a de plus grandes âmes qu'on ne le croirait.", u"Stendhal"),
(u"Sous la couche épaisse de nos actes, notre âme d'enfant demeure inchangée; l'âme échappe au temps.", u"François Mauriac, la fin de la nuit"),
(u"Je crois qu'on ne peut mieux vivre qu'en cherchant à devenir meilleur, ni plus agréablement qu'en ayant la pleine conscience de son amélioration.", u"Socrate"),
(u"Généralement, les gens qui savent peu parlent beaucoup, et les gens qui savent beaucoup parlent peu.", u"Jean-Jacques Rousseau"),
(u"N'estime l'argent ni plus ni moins qu'il ne vaut: c'est un bon serviteur et un mauvais maître.", u"Alexandre Dumas, fils, La Dame aux Camélias"),
(u"L'important ce n'est pas tellement d'avoir des souvenirs, c'est toujours de régler ses comptes avec eux.", u"Umberto Eco"),
(u"Nos modes de connaissances sont bien mathématiques. A eux sont indissolublement liés nos pouvoirs.", u"Lichnerowicz"),
(u"L'humanité serait depuis longtemps heureuse si tout le génie que les hommes mettent à réparer leurs bêtises, ils les employaient à ne pas les commettre.", u"George-Bernard Shaw"),
(u"Le pessimisme est d'humeur ; l'optimisme est de volonté.", u"Emile Chartier, [Alain]"),
(u"Laisser faire le bien et aider à le faire est chose plus difficile encore que de le faire soi-même.", u"Lacordaire"),
(u"Il ne faut pas tout pour faire un monde. Il faut du bonheur et rien d'autre.", u"Paul Eluard"),
(u"Le maître ne nous apprend rien d'autre que ceci, qu'il faut que chacun soit son propre maître, ce qui fait tous les hommes égaux.", u"Emile Chartier"),
(u"Ce n'est pas assez de faire des pas qui doivent un jour conduire au but, chaque pas doit être lui-même un but en même temps qu'il nous porte en avant.", u"Goethe, Conversations"),
(u"Quand un homme désire tuer un tigre, il appelle cela sport; quand un tigre désire le tuer, il appelle cela férocité.", u"George-Bernard Shaw, Maximes pour Révolutionnaires"),
(u"Le paradoxe humain c'est que tout est dit et que rien n'est compris.", u"Emile Chartier, dit Alain"),
(u"Tout pouvoir est méchant dès qu'on le laisse faire; tout pouvoir est sage dès qu'il se sent jugé.", u"Emile Chartier, dit Alain"),
(u"Plus on sait, et plus on est capable d'apprendre.", u"Emile Chartier, dit Alain"),
(u"La plus grande partie de la vie passe à  mal faire, une grande partie à ne rien faire, toute la vie à faire autre chose que ce que l'on devrait.", u"Sénèque"),
(u"C'est la fièvre de la jeunesse qui maintient le reste du monde à la température normale. Quand la jeunesse se refroidit, le reste du monde claque des dents.", u"Georges Bernanos"),
(u"Connaître les autres, c’est sagesse. Se connaître soi-même, c’est sagesse supérieure.", u"Lao-Tseu"), 
(u"Comment définir la méditation ? Comme la sagesse à la recherche de la sagesse.", u"Shunryu Suzuki"), 
(u"La philosophie n’est rien d’autre que l’amour de la sagesse.", u"Cicéron"), 
(u"Il y a plus d’une sagesse, et toutes sont nécessaires au monde ; il n’est pas mauvais qu’elles alternent.", u"Marguerite Yourcenar"), 
(u"C’est que la sagesse est un travail, et que pour être seulement raisonnable, il faut se donner beaucoup de mal, tandis que pour faire des sottises, il n’y a qu’à se laisser aller.", u"Alfred de Musset"), 
(u"La clef de toutes les sciences est sans contredit le point d’interrogation ; nous devons la plupart des grandes découvertes au comment ? Et la sagesse dans la vie consiste peut-être à se demander, à tout propos, pourquoi ?", u"Honoré de Balzac"), 
(u"On ne reçoit pas la sagesse, il faut la découvrir soi-même, après un trajet que personne ne peut faire pour nous, ne peut nous épargner.", u"Marcel Proust"),  
(u"Avant d’accomplir toutes choses, il faut parfaitement comprendre ce dont il s’agit : c’est la sagesse même.", u"Jean Filiatrault"), 
(u"Le plus haut degré de la sagesse humaine est de savoir plier son caractère aux circonstances et se faire un intérieur calme en dépit des orages extérieurs.", u"Daniel Defoe"), 
(u"Sur le Chemin, comme dans la vie, la sagesse n’a de valeur que si elle peut aider l’homme à vaincre un obstacle.", u"Paulo Coelho"), 
(u"La route de l’excès mène au palais de la sagesse.", u"William Blake"), 
(u"La sagesse des siècles nous apprend qu’il suffit d’approfondir une chose pour en connaître plusieurs autres..", u"Dan Millman"),  
(u"La sagesse du futur, celle qui évitera le suicide de l’humanité, ne consistera plus à gagner du temps mais à la remplir à le vivre, à en prendre toute la mesure.", u"Jacques Attali"),  
(u"Le chemin de la sagesse ou de la liberté est un chemin qui mène au centre de son propre être.", u"Mircea Eliade"), 
(u"L’homme ordinaire ne se préoccupe que de passer le temps, l’homme de talent que de l’employer.", u"Arthur Schopenhauer"), 
(u"Il n’y a pas d’enthousiasme sans sagesse, ni de sagesse sans générosité.", u"Paul Eluard"), 
(u"Conservons par la sagesse ce que nous avons acquis par l’enthousiasme.", u"Condorcet"),  
(u"La sagesse ne s’apprend pas, elle brille dans votre étoile.", u"Paul Fleming"), 
(u"La sagesse, c’est d’avoir des rêves suffisamment grands pour ne pas les perdre de vue lorsqu’on les poursuit.", u"Oscar Wilde"), 
(u"La sagesse suprême est d’avoir des rêves assez grands pour ne pas les perdre du regard tandis qu’on les poursuit.", u"William Faulkner"), 
(u"La vraie sagesse, la vraie supériorité ne se gagne pas en luttant mais en laissant les choses se faire d'elles-mêmes. Les plantes qui résistent au vent se cassent, alors que les plantes souples survivent aux ouragans. ", u"Epicure"),  
(u"Il faudrait naître vieux, débuter par la sagesse puis décider de son destin.", u"Ana Blandiana"), 
(u"Si ce n’est aujourd’hui, ce sera demain : rappelons-nous que la patience est le pilier de la sagesse.", u"Frédéric Mistral"), 
(u"Mêle à la sagesse un grain de folie ; il est bon quelquefois d’oublier la sagesse.", u"Horace"), 
(u"Il faut souvent donner à la sagesse l’air de la folie, afin de lui procurer ses entrées.", u"Denis Diderot"), 
(u"La sagesse est d’être fou lorsque les circonstances en valent la peine.", u"Jean Cocteau"), 
(u"J’ai toujours préféré la folie des passions à la sagesse de l’indifférence.", u"Anatole France"), 
(u"Quelle pitié que les fous ne puissent parler avec sagesse des folies que font les sages !", u"William Shakespeare"), 
(u"La sagesse a ses excès et n’a pas moins besoin de modération que la folie.", u"Montaigne"), 
(u"Le fou court après les plaisirs de la vie et trouve la déception ; le sage évite les maux.", u"Arthur Schopenhauer"),  
(u"O le plus fou de tous les hommes, toi qui aspires à la sagesse !", u"Didier Erasme"), 
(u"Quand vous voyez un homme sage, pensez à l’égaler en vertu. Quand vous voyez un homme dépourvu de sagesse, examinez-vous vous-même.", u"Confucius"), 
(u"La sagesse ne peut venir que de l’expérience.", u"Morihei Ueshiba"), 
(u"La vraie sagesse des nations est l’expérience.", u"Napoléon Bonaparte"), 
(u"Le doute est le commencement de la sagesse.", u"Aristote"), 
(u"Que la force me soit donnée de supporter ce qui ne peut être changé et le courage de changer ce qui peut l’être mais aussi la sagesse de distinguer l’un de l’autre.", u"Marc Aurèle"),  
(u"Le monde est à la volonté bien plus qu’à la sagesse.", u"Henri-Frédéric Amiel"), 
(u"Les progrès de l’humanité se mesurent aux  concessions que la folie des sages fait à la sagesse des fous.", u"Jean Jaurès"),  
(u"Le plaisir donne ce que la sagesse promet.", u"Voltaire"), 
(u"La connaissance parle, mais la sagesse écoute.", u"Jimi Hendrix"),  
(u"La sagesse est l’art de vivre.", u"Cicéron"), 
(u"La réflexion personnelle est l’école de la sagesse.", u"Baltasar Gracian Y Morales"), 
(u"Le sage cherche la sagesse, le sot l’a trouvée.", u"Georg Christoph Lichtenberg"), 
(u"Celui d’entre vous qui se croit sage, qu’il embrasse la folie pour trouver la sagesse.", u"Saint Paul"),  
(u"Chacun, parce qu’il pense, est le seul responsable de la sagesse ou de la folie de sa vie, c’est-à-dire de sa destinée.", u"Platon"), 
(u"La connaissance des êtres, l’étude de leur comportement est le commencement de la sagesse.", u"Madeleine Ferron"),
(u"La connaissance vient, mais la sagesse traîne.", u"Tennyson, Lockley Hall"),
(u"La liberté ne consiste pas seulement à suivre sa propre volonté, mais aussi parfois à la fuir.", u"Abe Kobo"),
(u"La solitude est un enfer pour ceux qui tentent d'en sortir; elle est aussi le bonheur pour les ermites qui se cachent.", u"Abe Kobo"),
(u"De toutes façons, le dicton « Connais-toi toi-même » n'est pas bien dit. Il eût été plus juste de dire: « Connais autrui ».", u"Ménandre, Thrasyleon"),
(u"Aimez qu'on vous conseille, et non pas qu'on vous loue.", u"Boileau, Art poétique"),
(u"Gardez toujours à l'esprit que votre propre décision de réussir est plus importante que n'importe quoi d'autre.", u"Abraham Lincoln"),
(u"Un bulletin de vote est plus fort qu'une balle de fusil.", u"Abraham Lincoln"),
(u"On peut tromper une partie du peuple tout le temps et tout le peuple une partie du temps, mais on ne peut pas tromper tout le peuple tout le temps.", u"Abraham Lincoln"),
(u"Ce que je veux savoir avant tout, ce n'est pas si vous avez échoué, mais si vous avez su accepter votre échec.", u"Abraham Lincoln"),
(u"L'ami qui n'est ami que par intérêt deviendra un ennemi, à coup sûr.", u"Abu Shakour"),
(u"Les gens bien élevés contredisent les autres. Les sages se contredisent eux-mêmes.", u"Oscar Wilde, Phrases et Philosophies"),
(u"Un homme qui a faim n'est pas un homme libre.", u"Adlaî Stevenson"),
(u"Je fais une proposition à  mes opposants: s'ils arrêtent de dire des mensonges sur nous, je cesserai de dire la vérité sur eux.", u"Adlaî Stevenson"),
(u"La seule chose que nous devons craindre est la crainte elle-mème.", u"Franklin-Delano Roosevelt, Premier discours inaugural"),
(u"Ce n'est pas avec la raison, et c'est le plus souvent contre elle, que s'édifient les croyances capables d'ébranler le monde.", u"Gustave Le Bon, Hier et Demain"),
(u"Supprimer la distance, c'est augmenter la durée du temps. Désormais, on ne vivra pas plus longtemps; seulement, on vivra plus vite.", u"Alexandre Dumas"),
(u"Quand tu souffres, regarde la douleur en face: elle te consolera elle-même et t'apprendra quelque chose.", u"Alexandre Dumas"),
(u"J'aime mieux les méchants que les imbéciles, parce qu'ils se reposent.", u"Alexandre Dumas"),
(u"Le monde ne sera pas détruit par ceux qui font le mal, et par ceux qui les regardent sans rien faire.", u"Albert Einstein"),
(u"Il n'existe que deux choses infinies, l'univers et la bêtise humaine... mais pour l'univers, je n'ai pas de certitude absolue.", u"Albert Einstein"),
(u"Ce n'est que lorsque les hommes vivent pour autrui, qu'ils commencent à vivre vraiment.", u"Albert Einstein"),
(u"L'imagination est plus importante que le savoir.", u"Albert Einstein"),
(u"Je ne pense jamais au futur, il vient bien assez vite comme ça...", u"Albert Einstein"),
(u"Il est plus difficile de désagréger un préjugé qu'un atome.", u"Albert Einstein"),
(u"Il n'y a rien de tel qu'une question idiote, seulement une réponse idiote.", u"Albert Einstein"),
(u"La théorie, c'est quand on sait tout et que rien ne fonctionne. La pratique, c'est quand tout fonctionne et que personne ne sait pourquoi.", u"Albert Einstein"),
(u"La vie, c'est comme une bicyclette: il faut avancer pour ne pas perdre l'équilibre.", u"Albert Einstein"),
(u"En apparence, la vie n'a aucun sens, et pourtant, il est impossible qu'il n'y en ait pas un!", u"Albert Einstein"),
(u"L'effort d'unir sagesse et pouvoir aboutit rarement et seulement très brièvement.", u"Albert Einstein"),
(u"Ce ne sont pas les différences d'opinion qui gènent le fonctionnement d'un groupe mais la rigidité de certains de ses membres.", u"Albert Einstein"),
(u"Je suis réellement un homme quand mes sentiments, mes pensées et mes actes n'ont qu'une finalité: celle de la communauté et de son progrès.", u"Albert Einstein"),
(u"Une personne qui n'a jamais commis d'erreurs n'a jamais innové.", u"Albert Einstein"),
(u"Il n'y a pas de situations désespérées; il y a seulement des hommes qui désespèrent des situations.", u"Anonyme"),
(u"Le bonheur est la seule chose qui se double si on le partage.", u"Albert Schweitzer"),
(u"Une grande misère parmi les hommes, c'est qu'ils savent si bien ce qui leur est dû et qu'ils sentent si peu ce qu'ils doivent aux autres.", u"Saint François de Sales"),
(u"La haine, c'est la colère des faibles.", u"Alphonse Daudet"),
(u"Après le pain, l'éducation est le premier besoin d'un peuple.", u"Danton"),
(u"Enrichissons-nous de nos différences mutuelles.", u"Paul Valéry"),
(u"Vous pouvez conduire un cheval à la rivière, mais il boira quand et ce qu'il lui plaira.", u"George Herbert, Jacula Prudentum"),
(u"Nous sommes du bonheur de nous-mêmes artisans, et fabriquons nos jours ou fâcheux ou plaisants.", u"Mathurin Régnier"),
(u"Les fous sont aux échecs les plus proches des rois.", u"Mathurin Régnier, Satires"),
(u"Chacun est artisan de sa bonne fortune.", u"Mathurin Régnier, Satires"),
(u"Les hommes disent que la vie est courte, et je vois qu'ils s'efforcent de la rendre telle.", u"Jean-Jacques Rousseau, Du contrat social, livre V"),
(u"La plus perdue de toutes les journées est celle où l'on n'a pas ri.", u"Sébastien Roch Nicolas, dit CHAMFORT, Maximes et pensées"),
(u"Celui qui ne sait pas se taire sait rarement bien parler.", u"Pierre Charron, De la sagesse"),
(u"Il faut beaucoup de naïveté pour faire de grandes choses.", u"René Crevel, L'Esprit contre la raison"),
(u"Tous les hommes sont égaux par la nature et devant la loi.", u"Déclaration des droits de l'homme et du citoyen"),
(u"Ce n'est pas assez d'avoir l'esprit bon, mais le principal est de l'appliquer bien.", u"René Descartes, Discours de la Méthode"),
(u"Quand l'orgueil chemine devant, honte et dommage suivent de près.", u"Gabriel Meurier, Trésor des sentences"),
(u"On ne peut pas tuer l'idée à coups de canon ni lui mettre les poucettes.", u"Louise Micehel, La Commune, avant-propos"),
(u"La plus subtile folie se fait de la plus subtile sagesse.", u"Michel de Montaigne, Essais, II, "),
(u"Les plus belles âmes sont celles qui ont plus de variété et de souplesse.", u"Michel de Montaigne, Essais III, "),
(u"L'éducation consiste à nous donner des idées, et la bonne éducation à les mettre en proportion.", u"Montesquieu, Essai sur les causes qui peuvent affecter les esprits et les caractères, seconde partie"),
(u"Il n'importe pas d'avoir été, mais d'être. Je ne sais pas: je serai. Seulement, parce que je prétends être plus que je ne suis, j'ai fait peu de cas que je fus pour devenir ce que je veux être.", u"Tirso de Molina"),
(u"Etudiez comme si vous deviez vivre toujours; vivez comme si vous deviez mourir demain.", u"Saint Isidore de Séville"),
(u"L'expérience, nom dont les hommes baptisent leurs erreurs.", u"Oscar Wilde, Le portrait de Dorian Gray"),
(u"L'expérience est une école sévère, mais les fous n'apprendront dans aucune autre.", u"Benjamin Franklin, L'Almanach du pauvre Richard"),
(u"L'esprit libre et curieux de l'homme est ce qui a le plus de prix au monde.", u"John Steinbeck, A l'Est de l'Eden"),
(u"Il ne suffit pas d'avoir de l'esprit. Il faut en avoir encore assez pour s'abstenir d'en avoir trop.", u"André Maurois, De la conversation"),
(u"Dis-moi qui t'admire et je te dirai qui tu es.", u"Charles Auguste Sainte-Beuve, Causeries du lundi"),
(u"La guerre n'est pas un aventure. La guerre est une maladie. Comme le typhus.", u"Antoine de Saint-Exupéry, Terre des hommes"),
(u"Nous ne sommes nous qu'aux yeux des autres et c'est à partir du regard des autres que nous nous assumons comme nous.", u"Jean-Paul Sartre, L'Être et le néant"),
(u"Tout le progrès de l'homme, toute l'histoire des sciences est l'histoire de la lutte de la raison contre le sacré.", u"Roger Vailland, Le Surréalisme contre la révolution"),
(u"Un homme seul est toujours en mauvaise compagnie.", u"Paul Valéry, Dialogues, L'idée fixe"),
(u"Ce qui m'intéresse, ce n'est pas le bonheur de tous les hommes c'est celui de chacun.", u"Boris Vian, L'Écume des jours"),
(u"La critique est une de ces professions qui prospèrent dans les temps malheureux.", u"François Villemain, Mélanges littéraires, Discours sur la critique"),
(u"Soyez patient avec tout le monde, mais surtout avec vous-même.", u"François De Sales"),
(u"Un homme vanne les fautes de son voisin comme paille et foin; les siennes, il les cache comme, devant un joueur, un tricheur le fait d'un dé truqué.", u"Le Dhammapada"),
(u"Il n'y a pas une idée qui vaille qu'on tue un homme.", u"Montaigne"),
(u"Les yeux de l'esprit ne commencent à être perçants que quand ceux du corps commencent à baisser. ", u"Platon"),
(u"Ne dis pas peu de choses en beaucoup de mots, mais dis beaucoup de choses en peu de mots.", u"Pythagore"),
(u"Nous n'héritons pas de la terre de nos parents, nous l'empruntons à nos enfants.", u"Proverbe Africain"),
(u"Ne perdez jamais patience, c'est la dernière clé qui ouvre la porte.", u"Saint Exupéry"),
(u"Examine si ce que tu promets est juste et possible, car la promesse est une dette.", u"Confucius"),
(u"L'Homme n'est rien d'autre que la série de ses actes.", u"Hegel"),
(u"Toute méchanceté a sa source dans la faiblesse.", u"Sénèque"),
(u"Rien ne vient à nous que falsifié et altéré par nos sens.", u"Montaigne"),
(u"Si vous ne pouvez expliquer un concept à un enfant de six ans, c'est que vous ne le comprenez pas complètement.", u"Albert Einstein"),
(u"La valeur d'un homme tient dans sa capacité à donner et non dans sa capacité à recevoir.", u"Albert Einstein"),
(u"Chacun a raison de son propre point de vue, mais il n'est pas impossible que tout le monde ait tort.", u"Gandhi"),
(u"Les gens ne connaissent pas leur bonheur, mais celui des autres ne leur échappe jamais.", u"P. Daninos"),
(u"Le plus grand obstacle à la vie est l'attente, qui espère demain et néglige aujourd'hui.", u"Sénèque"),
(u"Il y a un âge où les choses n'apparaissent pas; elles sont voilées par les mots. Il y a un âge où elles apparaissent: elles sont dévoilées par les silences.", u"Ernest Hello"),
(u"La guerre crée plus de méchants qu'elle n'en supprime.", u"Emmanuel Kant"),
(u"La médecine rend les hommes malades, la mathématique les rend tristes, la théologie les rend méchants.", u"Martin Luther"),
(u"Combien de sang l'innocent devra-t-il verser, avant que l'humanité se réveille et voie le monde tel qu'il est ?", u"Dominic Devost"),
(u"Voulez-vous apprendre et savoir quelque chose qui vous serve? Aimez à vivre inconnu et à n'être compté pour rien.", u"Michel de Marillac"),
(u"Nous ne pouvons lutter contre l'invincible découragement que par la continuité de l'effort.", u"Guy de Maupassant"),
(u"La menterie seule, et un peu au-dessous l'opiniâtreté, me semblent être celles desquelles on devrait à tout instant combattre la naissance et le progrès.", u"Montaigne"),
(u"Les critiques ne manquent jamais ces sortes de réflexion, parce qu'on les peut faire sans essayer beaucoup son esprit.", u"Montesquieu"),
(u"Qui vit sans folie, n'est pas si sage qu'on croit.", u"La Rochefoucauld, Maximes"),
(u"Les hommes ne vous trouvent sages que lorsqu'on partage ou qu'on approuve leur folie.", u"Alphonse Karr"),
(u"Sais-tu qui sont les mauvais pères? Ce sont ceux qui ont oublié les fautes de leur jeunesse.", u"Denis Diderot, Jacques le Fataliste et son maître"),
(u"L'indifférence fait les sages et l'insensibilité les monstres.", u"Denis Diderot, Encyclopédie"),
(u"Le travail, entre autres avantages, a celui de raccourcir les journées et d'étendre la vie.", u"Denis Diderot"),
(u"La guerre est un fruit de la dépravation des hommes; c'est une maladie convulsive et violente du corps politique; il n'est en santé, c'est-à-dire dans son état naturel, que lorsqu'il jouit de la paix.", u"Denis Diderot, Encyclopédie"),
(u"Celui qui disperse ses regards sur tout ne voit rien, ou voit mal.", u"Denis Diderot"),
(u"L'éloquence n'est que l'art d'embellir la logique.", u"Denis Diderot"),
(u"Je puis tout pardonner aux hommes, excepté l'injustice, l'ingratitude et l'inhumanité.", u"Denis Diderot, La Religieuse"),
(u"... aussi longtemps qu’il y a un homme dehors, la porte qui lui est fermée au nez ferme une cité d’injustice et de haine.", u"Charles Péguy"),
(u"... quand tout homme est pourvu du nécessaire, du vrai nécessaire, du pain et du livre, que nous importe la répartition du luxe?", u"Charles Péguy"),
(u"... le malheur, quand il entre chez nous, c'est rare qu'on ne lui ait pas nous-mêmes donné la clef.", u"Olivier Rolin"),
(u"Le fou se croit sage et le sage reconnaît lui-même n'être qu'un fou.", u"Shakespeare, Comme il vous plaira"),
(u"En France, le premier jour est pour l'engouement, le second pour la critique et le troisième pour l'indifférence.", u"Jean-François de La Harpe"),
(u"La France a trente-six millions de sujets sans compter les sujets de mécontentement.", u"Henri Rochefort, La lanterne"),
(u"Le génie représente un pour cent d'inspiration et quatre-vingt-dix-neuf pour cent de transpiration.", u"Thomas Alva Edison"),
(u"Le mal de la grandeur, c'est quand du pouvoir elle sépare la conscience.", u"Shakespeare, Jules César"),
(u"Il n'y a jamais eu de bonne guerre ni de mauvaise paix.", u"Benjamin Franklin, Lettre à J. Quincy"),
(u"Ignorance est mère de tous les maux.", u"Rabelais"),
(u"J'ai reconnu le bonheur au bruit qu'il a fait en partant.", u"Jacques Prévert"),
(u"Les fausses opinions ressemblent à la fausse monnaie qui est frappée d'abord par de grands coupables, et dépensée ensuite par d'honnêtes gens qui perpétuent le crime sans savoir ce qu'ils font.", u"Maistre"),
(u"Sur la terre, deux choses sont simples: raconter le passé et prédire l'avenir. Y voir clair au jour le jour est une autre entreprise.", u"Armand Salacrou"),
(u"Les vrais paradis sont les paradis qu'on a perdus.", u"Marcel Proust"),
(u"Les plus pessimistes d'aujourd'hui ont été les plus optimistes autrefois. Ils poursuivaient de vaines illusions. L'échec les a découragés.", u"Hou Che"),
(u"Il n'y a rien de bon ni de mauvais sauf ces deux choses: la sagesse qui est un bien et l'ignorance qui est un mal.", u"Platon"),
(u"Le bonheur n'est jamais immobile.", u"André Maurois"),
(u"La vérité de demain se nourrit de l'erreur d'hier.", u"Antoine de Saint-Exupéry"),
(u"Le bonheur ne consiste pas à acquérir ni à jouir, mais à ne rien désirer, car il consiste à être libre.", u"Epictète"),
(u"Le vrai bonheur coûte peu; s'il est cher, il n'est pas d'une bonne espèce.", u"François René"),
(u"La grande affaire et la seule qu'on doive avoir, c'est de vivre heureux.", u"Voltaire"),
(u"Il faut créer le bonheur pour protester contre l'univers du malheur.", u"Albert Camus"),
(u"Si tu veux comprendre le mot de bonheur, il faut l'entendre comme récompense et non comme but.", u"Antoine de Saint-Exupéry"),
(u"IL faut beaucoup de naïveté pour faire de grandes choses.", u"René Crevel"),
(u"Aucun homme n'a reçu de la nature le droit de commander les autres.", u"Denis Diderot"),
(u"Bonheur: faire ce que l'on veut et vouloir ce que l'on fait.", u"Françoise Giroud"),
(u"Le bonheur est quelque chose qui se multiplie quand il se divise.", u"Paolo Coelho"),
(u"Les hommes ne veulent pas construire leur bonheur, ils veulent seulement réduire leur malheur.", u"Bernard Werber"),
(u"Tout bonheur est un chef-d'œuvre: la moindre erreur le fausse, la moindre hésitation l'altère, la moindre lourdeur le dépare, la moindre sottise l'abêtit.", u"Yourcenar"),
(u"Il est plus désirable de cultiver le respect du bien que le respect de la loi.", u"Henri David Thoreau"),
(u"Le bonheur, c'est être heureux; ce n'est pas de faire croire aux autre qu'on l'est.", u"Jules Renard"),
(u"Un grand obstacle au bonheur, c'est de s'attendre à un trop grand bonheur.", u"Fontenelle"),
(u"Ce ne sont pas les richesses qui font le bonheur, mais l'usage qu'on en fait.", u"Cervantes"),
(u"Nous devons apprendre à vivre ensemble comme des frères, sinon nous allons mourir ensemble comme des idiots.", u"Martin Luther King"),
(u"La liberté n'est pas de faire ce que l'on veut mais de vouloir ce que l'on fait!", u"Jacques-Bénigne Bossuet"),
(u"La beauté n'est qu'un piège tendu par la nature à la raison.", u"Voltaire"),
(u"En opposant la haine à la haine, on ne fait que la répandre, en surface comme en profondeur.", u"Mahatma Ghandi, Tous les hommes sont frères"),
(u"Vivons donc heureusement, sans haïr ceux qui nous haïssent. Parmi ceux qui nous haïssent, passons dépourvu de haine.", u"Bouddha"),
(u"C'est finalement au plus fort de l'hiver, que j'ai compris qu'il existait en moi un invincible printemps.", u"Albert Camus"),
(u"J'ai décidé d'être heureux car c'est bon pour la santé.", u"Voltaire"),
(u"Le mot 'normal' ? Tout le monde sait ce que ça veut dire et pourtant personne ne sait donner la définition exacte.", u"Sarah Inari"),
(u"L'avenir nous tourmente, le passé nous retient, c'est pour ça que le présent nous échappe.", u"Gustave Flaubert"),
(u"Il faut avoir beaucoup de patience pour apprendre à être patient.", u"Stanislaw Jerzy Lec"),
(u"On regrette rarement d'avoir osé, mais toujours de ne pas avoir essayé.", u"Serge Lafrance"),
(u"La rose qui meurt de soif a besoin du jardinier, mais le jardinier a encore plus besoin de la rose qui meurt de soif: sans la soif de sa fleur, il n'existe pas.", u"Amélie Nothomb"),
(u"Toutes les vérités sont bonnes à dire, mais c'est nous qui ne sommes pas tous bons pour les entendre.", u"Alfred Capus"),
(u"La culture c'est comme la confiture, moins on en a, plus on étale...", u"Clément Derrien"),
(u"Il paraît que la crise rend les riches plus riches et les pauvres plus pauvres. Je ne vois pas en quoi c'est une crise. Depuis que je suis petit, c'est comme ça.", u"Coluche"),





]

