#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
#-----------------------------------------------------------
# Application :    Noethys, gestion multi-activits
# Site internet :  www.noethys.com
# Auteur:           Ivan LUCAS
# Copyright:       (c) 2010-11 Ivan LUCAS
# Licence:         Licence GNU GPL
#-----------------------------------------------------------

TABLES_IMPORTATION_OPTIONNELLES = [ 
        [u"Priodes de vacances", ("vacances",), True],
        [u"Jours fris", ("jours_feries",), True],
        [u"Vaccins et maladies", ("types_vaccins", "vaccins_maladies", "types_maladies",), True],
        [u"Types de sieste", ("types_sieste",), True],
        [u"Catgories socio-professionnelles", ("categories_travail",), True],
        [u"Modes et metteurs de rglements", ("modes_reglements", "emetteurs"), True],
        [u"Rgimes d'appartenance", ("regimes",), True],
        [u"Modles de documents", ("documents_modeles", "documents_objets"), True],
        [u"Modles d'Emails", ("modeles_emails",), True],
        [u"Niveaux scolaires", ("niveaux_scolaires",), True],
        [u"Comptes comptables", ("compta_comptes_comptables",), True],
        [u"Types de quotients", ("types_quotients",), True],
        ] # [Nom Categorie, (liste des tables...,), Selectionn]

TABLES_IMPORTATION_OBLIGATOIRES = []


DB_DATA = {

    "individus":[               ("IDindividu", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID de la personne"),
                                    ("IDcivilite", "INTEGER", u"Civilit de la personne"),
                                    ("nom", "VARCHAR(100)", u"Nom de famille de la personne"),
                                    ("nom_jfille", "VARCHAR(100)", u"Nom de jeune fille de la personne"),
                                    ("prenom", "VARCHAR(100)", u"Prnom de la personne"),
                                    ("num_secu", "VARCHAR(21)", u"Numro de scurit sociale de la personne"),
                                    ("IDnationalite", "INTEGER", u"Nationalit de la personne"),
                                    
                                    ("date_naiss", "DATE", u"Date de naissance de la personne"),
                                    ("IDpays_naiss", "INTEGER", u"ID du Pays de naissance de la personne"),
                                    ("cp_naiss", "VARCHAR(10)", u"Code postal du lieu de naissance de la personne"),
                                    ("ville_naiss", "VARCHAR(100)", u"Ville du lieu de naissance de la personne"),
                                    ("deces", "INTEGER", u"Est dcd (0/1)"),
                                    ("annee_deces", "INTEGER", u"Anne de dcs"),
                                    
                                    ("adresse_auto", "INTEGER", u"IDindividu dont l'adresse est  reporter"),
                                    ("rue_resid", "VARCHAR(255)", u"Adresse de la personne"),
                                    ("cp_resid", "VARCHAR(10)", u"Code postal de la personne"),
                                    ("ville_resid", "VARCHAR(100)", u"Ville de la personne"), 
                                    ("IDsecteur", "INTEGER", u"Secteur gographique"), 
                                    
                                    ("IDcategorie_travail", "INTEGER", u"IDcategorie socio-professionnelle"),
                                    ("profession", "VARCHAR(100)", u"Profession de la personne"),  
                                    ("employeur", "VARCHAR(100)", u"Employeur de la personne"), 
                                    ("travail_tel", "VARCHAR(50)", u"Tel travail de la personne"),  
                                    ("travail_fax", "VARCHAR(50)", u"Fax travail de la personne"),  
                                    ("travail_mail", "VARCHAR(50)", u"Email travail de la personne"),  
                                    
                                    ("tel_domicile", "VARCHAR(50)", u"Tel domicile de la personne"),  
                                    ("tel_mobile", "VARCHAR(50)", u"Tel mobile perso de la personne"),  
                                    ("tel_fax", "VARCHAR(50)", u"Fax perso de la personne"),  
                                    ("mail", "VARCHAR(50)", u"Email perso de la personne"),  
                                    
                                    ("IDmedecin", "INTEGER", u"ID du mdecin traitant de l'individu"),
                                    ("memo", "VARCHAR(2000)", u"Mmo concernant l'individu"),  
                                    ("IDtype_sieste", "INTEGER", u"Type de sieste"),
                                    
                                    ("date_creation", "DATE", u"Date de cration de la fiche individu"),
                                    ], # Les individus
    
    
    "liens":[                     ("IDlien", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du lien"),
                                    ("IDfamille", "INTEGER", u"IDfamille"),
                                    ("IDindividu_sujet", "INTEGER", u"IDindividu sujet du lien"),
                                    ("IDtype_lien", "INTEGER", u"IDtype_lien"),
                                    ("IDindividu_objet", "INTEGER", u"IDindividu objet du lien"),
                                    ("responsable", "INTEGER", u"=1 si l'individu SUJET est responsable de l'individu objet"),
                                    ("IDautorisation", "INTEGER", u"ID autorisation"),
                                    ], # Les liens entre les individus
    
    "familles":[                ("IDfamille", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID de la famille"),
                                    ("date_creation", "DATE", u"Date de cration de la fiche famille"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("IDcaisse", "INTEGER", u"ID de la caisse d'allocation"),
                                    ("num_allocataire", "VARCHAR(100)", u"Numro d'allocataire"),
                                    ("allocataire", "INTEGER", u"ID de l'individu allocataire principal"),
                                    ("internet_actif", "INTEGER", u"(0/1) Compte internet actif"),
                                    ("internet_identifiant", "VARCHAR(50)", u"Code identifiant internet"),
                                    ("internet_mdp", "VARCHAR(50)", u"Mot de passe internet"),
                                    ("memo", "VARCHAR(2000)", u"Mmo concernant la famille"),  
                                    ("prelevement_activation", "INTEGER", u"Activation du prlvement"),
                                    ("prelevement_etab", "VARCHAR(50)", u"Prlvement - Code tab"),
                                    ("prelevement_guichet", "VARCHAR(50)", u"Prlvement - Code guichet"),
                                    ("prelevement_numero", "VARCHAR(50)", u"Prlvement - Numro de compte"),
                                    ("prelevement_cle", "VARCHAR(50)", u"Prlvement - Code cl"),
                                    ("prelevement_banque", "INTEGER", u"Prlvement - ID de la Banque"),
                                    ("prelevement_individu", "INTEGER", u"Prlvement - ID Individu"),
                                    ("prelevement_nom", "VARCHAR(200)", u"Prlvement - nom titulaire"),
                                    ("prelevement_rue", "VARCHAR(400)", u"Prlvement - rue titulaire"),
                                    ("prelevement_cp", "VARCHAR(50)", u"Prlvement - cp titulaire"),
                                    ("prelevement_ville", "VARCHAR(400)", u"Prlvement - ville titulaire"),
                                    ("prelevement_cle_iban", "VARCHAR(10)", u"Prlvement - Cl IBAN"),
                                    ("prelevement_iban", "VARCHAR(100)", u"Prlvement - Cl IBAN"),
                                    ("prelevement_bic", "VARCHAR(100)", u"Prlvement - BIC"),
                                    ("prelevement_reference_mandat", "VARCHAR(300)", u"Prlvement - Rfrence mandat"),
                                    ("prelevement_date_mandat", "DATE", u"Prlvement - Date mandat"),
                                    ("prelevement_memo", "VARCHAR(450)", u"Prlvement - Mmo"),
                                    ("email_factures", "VARCHAR(450)", u"Adresse Email pour envoi des factures"),
                                    ("email_recus", "VARCHAR(450)", u"Adresse Email pour envoi des reus de rglements"),
                                    ("email_depots", "VARCHAR(450)", u"Adresse Email pour avis d'encaissement des rglements"),
                                    ("titulaire_helios", "INTEGER", u"IDindividu du titulaire Hlios"),
                                    ("code_comptable", "VARCHAR(450)", u"Code comptable pour facturation et export logiciels compta"),
                                    ("idtiers_helios", "VARCHAR(300)", u"IDtiers pour Hlios"),
                                    ("natidtiers_helios", "INTEGER", u"Nature IDtiers pour Hlios"),
                                    ("reftiers_helios", "VARCHAR(300)", u"Rfrence locale du tiers pour Hlios"),
                                    ("cattiers_helios", "INTEGER", u"Catgorie de tiers pour Hlios"),
                                    ("natjur_helios", "INTEGER", u"Nature juridique du tiers pour Hlios"),
                                    ("autorisation_cafpro", "INTEGER", u"Autorisation de consultation CAFPRO (0/1)"),
                                    ], # Les familles
    
    "rattachements":[       ("IDrattachement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID rattachement"),
                                    ("IDindividu", "INTEGER", u"IDindividu sujet du rattachement"),
                                    ("IDfamille", "INTEGER", u"IDfamille objet du rattachement"),
                                    ("IDcategorie", "INTEGER", u"IDcategorie du rattachement (responsable|enfant|contact)"),
                                    ("titulaire", "INTEGER", u"=1 si l'individu est titulaire de la fiche famille"),
                                    ], # Les rattachements  une ou plusieurs familles

    "types_maladies":[     ("IDtype_maladie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type_maladie"),
                                    ("nom", "VARCHAR(100)", u"Nom de la maladie"),
                                    ("vaccin_obligatoire", "INTEGER", u"=1 si vaccin obligatoire"),
                                    ], # Types de maladies

    "types_vaccins":[       ("IDtype_vaccin", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type_vaccin"),
                                    ("nom", "VARCHAR(100)", u"Nom du vaccin"),
                                    ("duree_validite", "VARCHAR(50)", u"Dure de validit"),
                                    ], # Les types de vaccins

    "vaccins_maladies":[  ("IDvaccins_maladies", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID vaccins_maladies"),
                                    ("IDtype_vaccin", "INTEGER", u"IDtype_vaccin"),
                                    ("IDtype_maladie", "INTEGER", u"IDtype_maladie"),
                                    ], # Liens entre les vaccins et les maladies concernes
    
    "medecins":[              ("IDmedecin", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du mdecin"),
                                    ("nom", "VARCHAR(100)", u"Nom de famille du mdecin"),
                                    ("prenom", "VARCHAR(100)", u"Prnom du mdecin"),
                                    ("rue_resid", "VARCHAR(255)", u"Adresse du mdecin"),
                                    ("cp_resid", "VARCHAR(10)", u"Code postal du mdecin"),
                                    ("ville_resid", "VARCHAR(100)", u"Ville du mdecin"),  
                                    ("tel_cabinet", "VARCHAR(50)", u"Tel du cabinet du mdecin"),  
                                    ("tel_mobile", "VARCHAR(50)", u"Tel du mobile du mdecin"),  
                                    ], # Les mdecins

    "vaccins":[                 ("IDvaccin", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du vaccin"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu concern"),
                                    ("IDtype_vaccin", "INTEGER", u"ID du vaccin concern"),
                                    ("date", "DATE", u"date du vaccin"),
                                    ], # Les vaccins des individus    

    "problemes_sante":[   ("IDprobleme", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du probleme de sant"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDtype", "INTEGER", u"ID du type de problme"),
                                    ("intitule", "VARCHAR(100)", u"Intitul du problme"),
                                    ("date_debut", "DATE", u"Date de dbut du problme"),
                                    ("date_fin", "DATE", u"Date de fin du problme"),
                                    ("description", "VARCHAR(2000)", u"Description du problme"),
                                    ("traitement_medical", "INTEGER", u"Traitement mdical (1/0)"),
                                    ("description_traitement", "VARCHAR(2000)", u"Description du traitement mdical"),
                                    ("date_debut_traitement", "DATE", u"Date de dbut du traitement"),
                                    ("date_fin_traitement", "DATE", u"Date de fin du traitement"),
                                    ("eviction", "INTEGER", u"Eviction (1/0)"),
                                    ("date_debut_eviction", "DATE", u"Date de dbut de l'viction"),
                                    ("date_fin_eviction", "DATE", u"Date de fin de l'viction"),
                                    ("diffusion_listing_enfants", "INTEGER", u"Diffusion listing enfants (1/0)"),
                                    ("diffusion_listing_conso", "INTEGER", u"Diffusion listing consommations (1/0)"),
                                    ("diffusion_listing_repas", "INTEGER", u"Diffusion commande des repas (1/0)"),
                                    ], # Les problmes de sant des individus  

    "vacances":[              ("IDvacance", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID periode vacances"),
                                    ("nom", "VARCHAR(100)", u"Nom de la priode de vacances"),
                                    ("annee", "INTEGER", u"Anne de la priode de vacances"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ], # Calendrier des jours de vacances

    "jours_feries":[           ("IDferie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID jour fri"),
                                    ("type", "VARCHAR(10)", u"Type de jour fri : fixe ou variable"),
                                    ("nom", "VARCHAR(100)", u"Nom du jour fri"),
                                    ("jour", "INTEGER", u"Jour de la date"),
                                    ("mois", "INTEGER", u"Mois de la date"),
                                    ("annee", "INTEGER", u"Anne de la date"),
                                    ], # Calendrier des jours fris variables et fixes

    "categories_travail":[   ("IDcategorie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID catgorie socio-professionnelle"),
                                    ("nom", "VARCHAR(100)", u"Nom de la catgorie"),
                                    ], # Catgories socio-professionnelles des individus

    "types_pieces":[        ("IDtype_piece", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type pice"),
                                    ("nom", "VARCHAR(100)", u"Nom de la pice"),
                                    ("public", "VARCHAR(12)", u"Public (individu ou famille)"),
                                    ("duree_validite", "VARCHAR(50)", u"Dure de validit"),
                                    ("valide_rattachement", "INTEGER", u"(0|1) Valide mme si individu rattach  une autre famille"),
                                    ], # Types de pices

    "pieces":[                  ("IDpiece", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Pice"),
                                    ("IDtype_piece", "INTEGER", u"IDtype_piece"),
                                    ("IDindividu", "INTEGER", u"IDindividu"),
                                    ("IDfamille", "INTEGER", u"IDfamille"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ], # Pices rattaches aux individus ou familles

    "organisateur":[          ("IDorganisateur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Organisateur"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'organisateur"),
                                    ("rue", "VARCHAR(200)", u"Adresse"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(100)", u"Ville"),  
                                    ("tel", "VARCHAR(50)", u"Tel travail"),  
                                    ("fax", "VARCHAR(50)", u"Fax travail"),  
                                    ("mail", "VARCHAR(100)", u"Email organisateur"),  
                                    ("site", "VARCHAR(100)", u"Adresse site internet"),  
                                    ("num_agrement", "VARCHAR(100)", u"Numro d'agrment"),  
                                    ("num_siret", "VARCHAR(100)", u"Numro SIRET"),  
                                    ("code_ape", "VARCHAR(100)", u"Code APE"),
                                    ("logo", "LONGBLOB", u"Logo de l'organisateur en binaire"),
                                    ("gps", "VARCHAR(200)", u"Coordonnes GPS au format 'lat;long' "),
                                    ("logo_update", "VARCHAR(50)", u"Horodatage de la dernire modification du logo"),
                                    ], # Organisateur

    "responsables_activite":[("IDresponsable", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Responsable"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("sexe", "VARCHAR(10)", u"Sexe de l'individu (H/F)"),
                                    ("nom", "VARCHAR(200)", u"Nom du responsable"),
                                    ("fonction", "VARCHAR(200)", u"Fonction"),
                                    ("defaut", "INTEGER", u"(0/1) Responsable slectionn par dfaut"),
                                    ], # Responsables de l'activit

    "activites":[               ("IDactivite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Activit"),
                                    ("nom", "VARCHAR(200)", u"Nom complet de l'activit"),
                                    ("abrege", "VARCHAR(50)", u"Nom abrg de l'activit"),
                                    ("coords_org", "INTEGER", u"(0/1) Coordonnes identiques  l'organisateur"),
                                    ("rue", "VARCHAR(200)", u"Adresse"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(100)", u"Ville"),  
                                    ("tel", "VARCHAR(50)", u"Tel travail"),  
                                    ("fax", "VARCHAR(50)", u"Fax travail"),  
                                    ("mail", "VARCHAR(100)", u"Email"),  
                                    ("site", "VARCHAR(100)", u"Adresse site internet"),
                                    ("logo_org", "INTEGER", u"(0/1) Logo identique  l'organisateur"),
                                    ("logo", "LONGBLOB", u"Logo de l'activit en binaire"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("public", "VARCHAR(20)", u"Liste du public"),
                                    ("vaccins_obligatoires", "INTEGER", u"(0/1) Vaccins obligatoires pour l'individu inscrit"),
                                    ("date_creation", "DATE", u"Date de cration de l'activit"),
                                    ("nbre_inscrits_max", "INTEGER", u"Nombre d'inscrits max"),
                                    ("code_comptable", "VARCHAR(450)", u"Code comptable pour facturation et export logiciels compta"),
                                    ("psu_activation", "INTEGER", u"Mode PSU : Activation"),
                                    ("psu_unite_prevision", "INTEGER", u"Mode PSU : IDunite prvision"),
                                    ("psu_unite_presence", "INTEGER", u"Mode PSU : IDunite prsence"),
                                    ("psu_tarif_forfait", "INTEGER", u"Mode PSU : IDtarif forfait-crdit"),
                                    ("psu_etiquette_rtt", "INTEGER", u"Mode PSU : IDetiquette Absences RTT"),
                                    ("portail_inscriptions_affichage", "INTEGER", u"Inscriptions autorises sur le portail (0/1)"),
                                    ("portail_inscriptions_date_debut", "DATETIME", u"Inscriptions autorises - dbut d'affichage"),
                                    ("portail_inscriptions_date_fin", "DATETIME", u"Inscriptions autorises - fin d'affichage"),
                                    ("portail_reservations_affichage", "INTEGER", u"Rservations autorises sur le portail (0/1)"),
                                    ("portail_reservations_limite", "VARCHAR(20)", u"Date limite de modification d'une rservation"),
                                    ("portail_reservations_absenti", "VARCHAR(20)", u"Application d'une absence injustifie"),
                                    ("portail_unites_multiples", "INTEGER", u"Slection multiple d'units autorise (0/1)"),
                                    ], # Activits

    "agrements":[            ("IDagrement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Agrment"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("agrement", "VARCHAR(200)", u"Numro d'agrment"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ], # Agrments de l'activit

    "groupes":[                ("IDgroupe", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Groupe"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("nom", "VARCHAR(200)", u"Nom du groupe"),
                                    ("abrege", "VARCHAR(100)", u"Nom abrg du groupe"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("nbre_inscrits_max", "INTEGER", u"Nombre d'inscrits max"),
                                    ], # Groupes

    "pieces_activites":[    ("IDpiece_activite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Pice activit"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDtype_piece", "INTEGER", u"ID du type de pice  fournir"),
                                    ], # Pices  fournir pour une activit

    "cotisations_activites":[("IDcotisation_activite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Cotisation activit"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDtype_cotisation", "INTEGER", u"ID du type de cotisation  fournir"),
                                    ], # Cotisations  avoir pour une activit

    "renseignements_activites":[("IDrenseignement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Renseignement"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDtype_renseignement", "INTEGER", u"ID du type de renseignement  fournir"),
                                    ], # Informations  renseigner par les individus pour une activit

    "restaurateurs":[        ("IDrestaurateur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Restaurateur"),
                                    ("nom", "VARCHAR(200)", u"Nom du restaurateur"),
                                    ("rue", "VARCHAR(200)", u"Adresse"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(100)", u"Ville"),  
                                    ("tel", "VARCHAR(50)", u"Tel travail"),  
                                    ("fax", "VARCHAR(50)", u"Fax travail"),  
                                    ("mail", "VARCHAR(100)", u"Email"),  
                                    ], # Restaurateurs

    "unites":[                   ("IDunite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Unit"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'unit"),
                                    ("abrege", "VARCHAR(50)", u"Nom abrg"),
                                    ("type", "VARCHAR(20)", u"Type (unitaire/horaire)"),
                                    ("heure_debut", "DATE", u"Horaire minimum"),
                                    ("heure_debut_fixe", "INTEGER", u"Heure de dbut fixe (0/1)"),
                                    ("heure_fin", "DATE", u"Horaire maximal"),  
                                    ("heure_fin_fixe", "INTEGER", u"Heure de fin fixe (0/1)"),
                                    ("repas", "INTEGER", u"Repas inclus (0/1)"),  
                                    ("IDrestaurateur", "INTEGER", u"IDrestaurateur"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),  
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("touche_raccourci", "VARCHAR(30)", u"Touche de raccourci pour la grille de saisie"), 
                                    ("largeur", "INTEGER", u"Largeur de colonne en pixels"),
                                    ("coeff", "VARCHAR(50)", u"Coeff pour tat global"),
                                    ("autogen_active", "INTEGER", u"Autognration active (0/1)"),
                                    ("autogen_conditions", "VARCHAR(400)", u"Conditions de l'autognration"),
                                    ("autogen_parametres", "VARCHAR(400)", u"Paramtres de l'autognration"),
                                    ], # Units

    "unites_groupes":[      ("IDunite_groupe", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Unit_groupe"),
                                    ("IDunite", "INTEGER", u"ID de l'unit concerne"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe associ"),  
                                    ], # Groupes concerns par l'unit

    "unites_incompat":[    ("IDunite_incompat", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Unit_incompat"),
                                    ("IDunite", "INTEGER", u"ID de l'unit concerne"),
                                    ("IDunite_incompatible", "INTEGER", u"ID de l'unit incompatible"),  
                                    ], # Units incompatibles entre elles

    "unites_remplissage":[("IDunite_remplissage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Unit_remplissage"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'unit de remplissage"),
                                    ("abrege", "VARCHAR(50)", u"Nom abrg"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),  
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("seuil_alerte", "INTEGER", u"Seuil d'alerte de remplissage"),
                                    ("heure_min", "DATE", u"Plage horaire conditionnelle - Heure min"),
                                    ("heure_max", "DATE", u"Plage horaire conditionnelle - Heure max"),  
                                    ("afficher_page_accueil", "INTEGER", u"Afficher dans le cadre Effectifs de la page d'accueil"),
                                    ("afficher_grille_conso", "INTEGER", u"Afficher dans la grille des conso"),
                                    ("etiquettes", "VARCHAR(450)", u"Etiquettes associes"),
                                    ], # Units de remplissage

    "unites_remplissage_unites":[("IDunite_remplissage_unite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Unit_remplissage_unite"),
                                    ("IDunite_remplissage", "INTEGER", u"ID de l'unit de remplissage concerne"),
                                    ("IDunite", "INTEGER", u"ID de l'unit associe"),  
                                    ], # Units associes aux units de remplissage
                                    
    "ouvertures":[             ("IDouverture", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID ouverture"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDunite", "INTEGER", u"ID de l'unit concerne"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe concern"),
                                    ("date", "DATE", u"Date de l'ouverture"),  
                                    ], # Jours de fonctionnement des units
                                    
    "remplissage":[          ("IDremplissage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID remplissage"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDunite_remplissage", "INTEGER", u"ID de l'unit de remplissage concerne"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe concern"),
                                    ("date", "DATE", u"Date de l'ouverture"),
                                    ("places", "INTEGER", u"Nbre de places"),  
                                    ], # Nbre de places maxi pour chaque unit de remplissage

    "categories_tarifs":[    ("IDcategorie_tarif", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Catgorie de tarif"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("nom", "VARCHAR(200)", u"Nom de la catgorie"),
                                    ], # Catgories de tarifs

    "categories_tarifs_villes":[("IDville", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Ville"),
                                    ("IDcategorie_tarif", "INTEGER", u"ID de la catgorie de tarif concerne"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("nom", "VARCHAR(100)", u"Nom de la ville"),
                                    ], # Villes rattaches aux catgories de tarifs

    "noms_tarifs":[           ("IDnom_tarif", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID nom tarif"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDcategorie_tarif", "INTEGER", u"ID categorie_tarif rattache"),
                                    ("nom", "VARCHAR(200)", u"Nom du tarif"),
                                    ], # Noms des tarifs

    "tarifs":[                    ("IDtarif", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID tarif"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("type", "VARCHAR(50)", u"Type de tarif"),
                                    ("IDcategorie_tarif", "INTEGER", u"ID categorie_tarif rattache"),
                                    ("IDnom_tarif", "INTEGER", u"ID nom du tarif"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),  
                                    ("condition_nbre_combi", "INTEGER", u""),
                                    ("condition_periode", "VARCHAR(100)", u"Type de tarif (prdfini ou automatique)"),
                                    ("condition_nbre_jours", "INTEGER", u""),
                                    ("condition_conso_facturees", "INTEGER", u""),
                                    ("condition_dates_continues", "INTEGER", u""),
                                    ("forfait_saisie_manuelle", "INTEGER", u"Saisie manuelle du forfait possible (0/1)"),
                                    ("forfait_saisie_auto", "INTEGER", u"Saisie automatique du forfait quand inscription (0/1)"),
                                    ("forfait_suppression_auto", "INTEGER", u"Suppression manuelle impossible (0/1)"),
                                    ("methode", "VARCHAR(50)", u"Code de la mthode de calcul"),
                                    ("categories_tarifs", "VARCHAR(300)", u"Catgories de tarifs rattaches  ce tarif"),
                                    ("groupes", "VARCHAR(300)", u"Groupes rattachs  ce tarif"),
                                    ("forfait_duree", "VARCHAR(50)", u"Dure du forfait"),
                                    ("forfait_beneficiaire", "VARCHAR(50)", u"Bnficiaire du forfait (famille|individu)"),
                                    ("cotisations", "VARCHAR(300)", u"Cotisations rattaches  ce tarif"),
                                    ("caisses", "VARCHAR(300)", u"Caisses rattaches  ce tarif"),
                                    ("description", "VARCHAR(450)", u"Description du tarif"),
                                    ("jours_scolaires", "VARCHAR(100)", u"Jours scolaires"),
                                    ("jours_vacances", "VARCHAR(100)", u"Jours de vacances"),
                                    ("options", "VARCHAR(450)", u"Options diverses"),
                                    ("observations", "VARCHAR(450)", u"Observations sur le tarif"),
                                    ("tva", "FLOAT", u"Taux TVA"),
                                    ("code_compta", "VARCHAR(200)", u"Code comptable pour export vers logiciels de compta"),
                                    ("date_facturation", "VARCHAR(450)", u"Date de facturation de la prestation"),
                                    ("etiquettes", "VARCHAR(450)", u"Etiquettes rattaches  ce tarif"),
                                    ("etats", "VARCHAR(150)", u"Etats de consommations rattachs  ce tarif"),
                                    ("IDtype_quotient", "INTEGER", u"ID du type de quotient"),
                                    ("label_prestation", "VARCHAR(300)", u"Label de la prestation"),
                                    ], # Tarifs

    "combi_tarifs":          [("IDcombi_tarif", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID combinaison de tarif"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("type", "VARCHAR(50)", u"Type de combinaison"),
                                    ("date", "DATE", u"Date si dans forfait"),
                                    ("quantite_max", "INTEGER", u"Quantit max d'units"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe concern"),
                                    ], # Combinaisons d'units pour les tarifs

    "combi_tarifs_unites":[("IDcombi_tarif_unite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID combinaison de tarif"),
                                    ("IDcombi_tarif", "INTEGER", u"ID du combi_tarif"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("IDunite", "INTEGER", u"ID de l'unit"),
                                    ], # Combinaisons d'units pour les tarifs

    "tarifs_lignes":          [("IDligne", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID ligne de tarif"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("code", "VARCHAR(50)", u"Code de la mthode"),
                                    ("num_ligne", "INTEGER", u"Numro de ligne"),
                                    ("tranche", "VARCHAR(10)", u"Nom de tranche"),
                                    ("qf_min", "FLOAT", u"Montant QF min"),
                                    ("qf_max", "FLOAT", u"Montant QF max"),
                                    ("montant_unique", "FLOAT", u"Montant unique"),
                                    ("montant_enfant_1", "FLOAT", u"Montant pour 1 enfant"),
                                    ("montant_enfant_2", "FLOAT", u"Montant pour 2 enfants"),
                                    ("montant_enfant_3", "FLOAT", u"Montant pour 3 enfants"),
                                    ("montant_enfant_4", "FLOAT", u"Montant pour 4 enfants"),
                                    ("montant_enfant_5", "FLOAT", u"Montant pour 5 enfants"),
                                    ("montant_enfant_6", "FLOAT", u"Montant pour 6 enfants et plus"),
                                    ("nbre_enfants", "INTEGER", u"Nbre d'enfants pour le calcul par taux d'effort"),
                                    ("coefficient", "FLOAT", u"Coefficient"),
                                    ("montant_min", "FLOAT", u"Montant mini pour le calcul par taux d'effort"),
                                    ("montant_max", "FLOAT", u"Montant maxi pour le calcul par taux d'effort"),
                                    ("heure_debut_min", "DATE", u"Heure dbut min pour units horaires"),  
                                    ("heure_debut_max", "DATE", u"Heure dbut max pour units horaires"),  
                                    ("heure_fin_min", "DATE", u"Heure fin min pour units horaires"),  
                                    ("heure_fin_max", "DATE", u"Heure fin max pour units horaires"), 
                                    ("duree_min", "DATE", u"Dure min pour units horaires"), 
                                    ("duree_max", "DATE", u"Dure min pour units horaires"), 
                                    ("date", "DATE", u"Date conditionnelle"), 
                                    ("label", "VARCHAR(300)", u"Label personnalis pour la prestation"), 
                                    ("temps_facture", "DATE", u"Temps factur pour la CAF"), 
                                    ("unite_horaire", "DATE", u"Unit horaire pour base de calcul selon coefficient"), 
                                    ("duree_seuil", "DATE", u"Dure seuil"), 
                                    ("duree_plafond", "DATE", u"Dure plafond"), 
                                    ("taux", "FLOAT", u"Taux d'effort"), 
                                    ("ajustement", "FLOAT", u"Ajustement (majoration/dduction)"), 
                                    ("montant_questionnaire", "INTEGER", u"IDquestion de la table questionnaires"),
                                    ("revenu_min", "FLOAT", u"Montant revenu min"),
                                    ("revenu_max", "FLOAT", u"Montant revenu max"),
                                    ], # Lignes du tableau de calcul de tarifs
                                    
    "inscriptions":[           ("IDinscription", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID inscription"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe"),
                                    ("IDcategorie_tarif", "INTEGER", u"ID de la catgorie de tarif"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur par dfaut"), 
                                    ("date_inscription", "DATE", u"Date de l'inscription"),
                                    ("parti", "INTEGER", u"(0/1) est parti"),
                                    ("date_desinscription", "DATE", u"Date de dsinscription"),
                                    ], # Inscriptions des individus  des activits

    "consommations":[    ("IDconso", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID consommation"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDinscription", "INTEGER", u"ID de l'inscription"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("date", "DATE", u"Date de la consommation"),
                                    ("IDunite", "INTEGER", u"ID de l'unit"),
                                    ("IDgroupe", "INTEGER", u"ID du groupe"),
                                    ("heure_debut", "DATE", u"Heure min pour units horaires"),  
                                    ("heure_fin", "DATE", u"Heure max pour units horaires"),  
                                    ("etat", "VARCHAR(20)", u"Etat"),
                                    ("verrouillage", "INTEGER", u"1 si la consommation est verrouille"),
                                    ("date_saisie", "DATE", u"Date de saisie de la consommation"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a fait la saisie"),
                                    ("IDcategorie_tarif", "INTEGER", u"ID de la catgorie de tarif"), 
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("IDprestation", "INTEGER", u"ID de la prestation"),
                                    ("forfait", "INTEGER", u"Type de forfait : 0 : Aucun | 1 : Suppr possible | 2 : Suppr impossible"),
                                    ("quantite", "INTEGER", u"Quantit de consommations"),
                                    ("etiquettes", "VARCHAR(50)", u"Etiquettes"),
                                    ], # Consommations

    "memo_journee":[      ("IDmemo", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID memo"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("date", "DATE", u"Date"),
                                    ("texte", "VARCHAR(200)", u"Texte du mmo"),
                                    ], # Mmo journes

    "prestations":[           ("IDprestation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID prestation"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("date", "DATE", u"Date de la prestation"),
                                    ("categorie", "VARCHAR(50)", u"Catgorie de la prestation"),
                                    ("label", "VARCHAR(200)", u"Label de la prestation"),
                                    ("montant_initial", "FLOAT", u"Montant de la prestation AVANT dductions"),
                                    ("montant", "FLOAT", u"Montant de la prestation"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("IDfacture", "INTEGER", u"ID de la facture"),
                                    ("IDfamille", "INTEGER", u"ID de la famille concerne"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu concern"),
                                    ("forfait", "INTEGER", u"Type de forfait : 0 : Aucun | 1 : Suppr possible | 2 : Suppr impossible"),
                                    ("temps_facture", "DATE", u"Temps factur format 00:00"),  
                                    ("IDcategorie_tarif", "INTEGER", u"ID de la catgorie de tarif"),
                                    ("forfait_date_debut", "DATE", u"Date de dbut de forfait"),  
                                    ("forfait_date_fin", "DATE", u"Date de fin de forfait"),  
                                    ("reglement_frais", "INTEGER", u"ID du rglement"),
                                    ("tva", "FLOAT", u"Taux TVA"),
                                    ("code_compta", "VARCHAR(200)", u"Code comptable pour export vers logiciels de compta"),
                                    ("IDcontrat", "INTEGER", u"ID du contrat associ"),
                                    ("date_valeur", "DATE", u"Date de valeur comptable de la prestation"),
                                    ], # Prestations

    "comptes_payeurs":[  ("IDcompte_payeur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID compte_payeur"),
                                    ("IDfamille", "INTEGER", u"ID de la famille concerne"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu concern"),
                                    ], # Comptes payeurs

    "modes_reglements":[("IDmode", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID mode de rglement"),
                                    ("label", "VARCHAR(100)", u"Label du mode"),
                                    ("image", "LONGBLOB", u"Image du mode"),
                                    ("numero_piece", "VARCHAR(10)", u"Numro de pice (None|ALPHA|NUM)"),
                                    ("nbre_chiffres", "INTEGER", u"Nbre de chiffres du numro"),
                                    ("frais_gestion", "VARCHAR(10)", u"Frais de gestion None|LIBRE|FIXE|PRORATA"),
                                    ("frais_montant", "FLOAT", u"Montant fixe des frais"),
                                    ("frais_pourcentage", "FLOAT", u"Prorata des frais"),
                                    ("frais_arrondi", "VARCHAR(20)", u"Mthode d'arrondi"),
                                    ("frais_label", "VARCHAR(200)", u"Label de la prestation"),
                                    ("type_comptable", "VARCHAR(200)", u"Type comptable (banque ou caisse)"),
                                    ("code_compta", "VARCHAR(200)", u"Code comptable pour export vers logiciels de compta"),
                                    ], # Modes de rglements

    "emetteurs":[             ("IDemetteur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Emetteur"),
                                    ("IDmode", "INTEGER", u"ID du mode concern"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'metteur"),
                                    ("image", "LONGBLOB", u"Image de l'emetteur"),
                                    ], # Emetteurs pour les modes de rglements

    "payeurs":[                ("IDpayeur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Payeur"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur concern"),
                                    ("nom", "VARCHAR(100)", u"Nom du payeur"),
                                    ], # Payeurs

    "comptes_bancaires":[("IDcompte", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Compte"),
                                    ("nom", "VARCHAR(100)", u"Intitul du compte"),
                                    ("numero", "VARCHAR(50)", u"Numro du compte"),
                                    ("defaut", "INTEGER", u"(0/1) Compte slectionn par dfaut"),
                                    ("raison", "VARCHAR(400)", u"Raison sociale"),
                                    ("code_etab", "VARCHAR(400)", u"Code tablissement"),
                                    ("code_guichet", "VARCHAR(400)", u"Code guichet"),
                                    ("code_nne", "VARCHAR(400)", u"Code NNE pour prlvements auto."),
                                    ("cle_rib", "VARCHAR(400)", u"Cl RIB pour prlvements auto."),
                                    ("cle_iban", "VARCHAR(400)", u"Cl IBAN pour prlvements auto."),
                                    ("iban", "VARCHAR(400)", u"Numro IBAN pour prlvements auto."),
                                    ("bic", "VARCHAR(400)", u"Numro BIC pour prlvements auto."),
                                    ("code_ics", "VARCHAR(400)", u"Code NNE pour prlvements auto."),
                                    ], # Comptes bancaires de l'organisateur
                                    
    "reglements":[            ("IDreglement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Rglement"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("date", "DATE", u"Date d'mission du rglement"),
                                    ("IDmode", "INTEGER", u"ID du mode de rglement"),
                                    ("IDemetteur", "INTEGER", u"ID de l'metteur du rglement"),
                                    ("numero_piece", "VARCHAR(30)", u"Numro de pice"),
                                    ("montant", "FLOAT", u"Montant du rglement"),
                                    ("IDpayeur", "INTEGER", u"ID du payeur"),
                                    ("observations", "VARCHAR(200)", u"Observations"),
                                    ("numero_quittancier", "VARCHAR(30)", u"Numro de quittancier"),
                                    ("IDprestation_frais", "INTEGER", u"ID de la prestation de frais de gestion"),
                                    ("IDcompte", "INTEGER", u"ID du compte bancaire pour l'encaissement"),
                                    ("date_differe", "DATE", u"Date de l'encaissement diffr"),
                                    ("encaissement_attente", "INTEGER", u"(0/1) Encaissement en attente"),
                                    ("IDdepot", "INTEGER", u"ID du dpt"),
                                    ("date_saisie", "DATE", u"Date de saisie du rglement"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a fait la saisie"),
                                    ("IDprelevement", "INTEGER", u"ID du prlvement"),
                                    ("avis_depot", "DATE", u"Date de l'envoi de l'avis de dpt"),
                                    ("IDpiece", "INTEGER", u"IDpiece pour PES V2 ORMC"),
                                    ], # Rglements

    "ventilation":[             ("IDventilation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Ventilation"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("IDreglement", "INTEGER", u"ID du rglement"),
                                    ("IDprestation", "INTEGER", u"ID de la prestation"),
                                    ("montant", "FLOAT", u"Montant de la ventilation"),
                                    ], # Ventilation

    "depots":[                  ("IDdepot", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Dpt"),
                                    ("date", "DATE", u"Date du dpt"),
                                    ("nom", "VARCHAR(200)", u"Nom du dpt"),
                                    ("verrouillage", "INTEGER", u"(0/1) Verrouillage du dpt"),
                                    ("IDcompte", "INTEGER", u"ID du compte d'encaissement"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("code_compta", "VARCHAR(200)", u"Code comptable pour export vers logiciels de compta"),
                                    ], # Dpts

    "quotients":[              ("IDquotient", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Quotient familial"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("quotient", "INTEGER", u"Quotient familial"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("revenu", "FLOAT", u"Montant du revenu"),
                                    ("IDtype_quotient", "INTEGER", u"Type de quotient"),
                                    ], # Quotients familiaux

    "caisses":[                ("IDcaisse", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Caisse"),
                                    ("nom", "VARCHAR(255)", u"Nom de la caisse"),
                                    ("IDregime", "INTEGER", u"Rgime social affili"),
                                    ], # Caisses d'allocations

    "regimes":[                ("IDregime", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Rgime"),
                                    ("nom", "VARCHAR(255)", u"Nom du rgime social"),
                                    ], # Rgimes sociaux

    "aides":[                    ("IDaide", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Aide"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'aide"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("IDcaisse", "INTEGER", u"ID de la caisse"),
                                    ("montant_max", "FLOAT", u"Montant maximal de l'aide"),
                                    ("nbre_dates_max", "INTEGER", u"Nbre maximal de dates"),
                                    ("jours_scolaires", "VARCHAR(50)", u"Jours scolaires"),
                                    ("jours_vacances", "VARCHAR(50)", u"Jours de vacances"),
                                    ], # Aides journalires

    "aides_beneficiaires":[("IDaide_beneficiaire", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID bnficiaire"),
                                    ("IDaide", "INTEGER", u"ID de l'aide"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ], # Bnficiaires des aides journalires

    "aides_montants":[    ("IDaide_montant", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Aide montant"),
                                    ("IDaide", "INTEGER", u"ID de l'aide"),
                                    ("montant", "FLOAT", u"Montant"),
                                    ], # Montants des aides journalires

    "aides_combinaisons":[("IDaide_combi", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Combinaison"),
                                    ("IDaide", "INTEGER", u"ID de l'aide"),
                                    ("IDaide_montant", "INTEGER", u"ID de l'aide"),
                                    ], # Combinaisons d'units pour les aides journalires

    "aides_combi_unites":[("IDaide_combi_unite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID unit pour Combinaison"),
                                    ("IDaide", "INTEGER", u"ID de l'aide"),
                                    ("IDaide_combi", "INTEGER", u"ID de la combinaison"),
                                    ("IDunite", "INTEGER", u"ID de l'unit"),
                                    ], # Units des combinaisons pour les aides journalires

    "deductions":[           ("IDdeduction", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID dduction"),
                                    ("IDprestation", "INTEGER", u"ID de la prestation"),
                                    ("IDcompte_payeur", "INTEGER", u"IDcompte_payeur"),
                                    ("date", "DATE", u"Date de la dduction"),
                                    ("montant", "FLOAT", u"Montant"),
                                    ("label", "VARCHAR(200)", u"Label de la dduction"),
                                    ("IDaide", "INTEGER", u"ID de l'aide"),
                                    ], # Dductions pour les prestations

    "types_cotisations":[  ("IDtype_cotisation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type cotisation"),
                                    ("nom", "VARCHAR(200)", u"Nom de la cotisation"),
                                    ("type", "VARCHAR(50)", u"Type de cotisation (individu/famille)"),
                                    ("carte", "INTEGER", u"(0/1) Est une carte d'adhrent"),
                                    ("defaut", "INTEGER", u"(0/1) Cotisation slectionne par dfaut"),
                                    ("code_comptable", "VARCHAR(450)", u"Code comptable pour facturation et export logiciels compta"),
                                    ], # Types de cotisations

    "unites_cotisations":[ ("IDunite_cotisation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID unit cotisation"),
                                    ("IDtype_cotisation", "INTEGER", u"ID du type de cotisation"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'unit de cotisation"),
                                    ("montant", "FLOAT", u"Montant"),
                                    ("label_prestation", "VARCHAR(200)", u"Label de la prestation"),
                                    ("defaut", "INTEGER", u"(0/1) Unit slectionne par dfaut"),
                                    ], # Units de cotisation

    "cotisations":[            ("IDcotisation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID cotisation"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDtype_cotisation", "INTEGER", u"ID du type de cotisation"),
                                    ("IDunite_cotisation", "INTEGER", u"ID de l'unit de cotisation"),
                                    ("date_saisie", "DATE", u"Date de saisie"),
                                    ("IDutilisateur", "INTEGER", u"ID de l'utilisateur"),
                                    ("date_creation_carte", "DATE", u"Date de cration de la carte"),
                                    ("numero", "VARCHAR(50)", u"Numro d'adhrent"),
                                    ("IDdepot_cotisation", "INTEGER", u"ID du dpt des cotisations"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("date_fin", "DATE", u"Date de fin de validit"),
                                    ("IDprestation", "INTEGER", u"ID de la prestation associe"),
                                    ("observations", "VARCHAR(1000)", u"Observations"),
                                    ("activites", "VARCHAR(450)", u"Liste d'activits associes"),
                                    ], # Cotisations

    "depots_cotisations":[("IDdepot_cotisation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Dpt Cotisation"),
                                    ("date", "DATE", u"Date du dpt"),
                                    ("nom", "VARCHAR(200)", u"Nom du dpt"),
                                    ("verrouillage", "INTEGER", u"(0/1) Verrouillage du dpt"),
                                    ("observations", "VARCHAR(1000)", u"Observations"),
                                    ], # Dpts de cotisations

    "parametres":[           ("IDparametre", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID parametre"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie"),
                                    ("nom", "VARCHAR(200)", u"Nom"),
                                    ("parametre", "VARCHAR(30000)", u"Parametre"),
                                    ], # Paramtres

    "types_groupes_activites":[("IDtype_groupe_activite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type groupe activit"),
                                    ("nom", "VARCHAR(255)", u"Nom"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ], # Types de groupes d'activits

    "groupes_activites":[  ("IDgroupe_activite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type groupe activit"),
                                    ("IDtype_groupe_activite", "INTEGER", u"ID du groupe d'activit"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit concerne"),
                                    ], # Groupes d'activits

    "secteurs":[               ("IDsecteur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID secteur gographique"),
                                    ("nom", "VARCHAR(255)", u"Nom du secteur gographique"),
                                    ], # Secteurs gographiques

    "types_sieste":[         ("IDtype_sieste", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID type sieste"),
                                    ("nom", "VARCHAR(255)", u"Nom du type de sieste"),
                                    ], # Types de sieste

    "factures_messages":[("IDmessage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmessage"),
                                    ("titre", "VARCHAR(255)", u"Titre du message"),
                                    ("texte", "VARCHAR(1000)", u"Contenu du message"),
                                    ], # Messages dans les factures

    "factures":[                ("IDfacture", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDfacture"),
                                    ("numero", "INTEGER", u"Numro de facture"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("date_edition", "DATE", u"Date d'dition de la facture"),
                                    ("date_echeance", "DATE", u"Date d'chance de la facture"),
                                    ("activites", "VARCHAR(500)", u"Liste des IDactivit spares par ;"),
                                    ("individus", "VARCHAR(500)", u"Liste des IDindividus spares par ;"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a cr la facture"),
                                    ("date_debut", "DATE", u"Date de dbut de priode"),
                                    ("date_fin", "DATE", u"Date de fin de priode"),
                                    ("total", "FLOAT", u"Montant total de la priode"),
                                    ("regle", "FLOAT", u"Montant rgl pour la priode"),
                                    ("solde", "FLOAT", u"Solde  rgler pour la priode"),
                                    ("IDlot", "INTEGER", u"ID du lot de factures"),
                                    ("prestations", "VARCHAR(500)", u"Liste des types de prestations intgres"),
                                    ("etat", "VARCHAR(100)", u"Etat de la facture"),
                                    ("IDprefixe", "INTEGER", u"ID du prfixe"),
                                    ], # Factures dites

    "textes_rappels":[      ("IDtexte", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDtexte"),
                                    ("label", "VARCHAR(255)", u"Label du texte"),
                                    ("couleur", "VARCHAR(50)", u"Couleur"),
                                    ("retard_min", "INTEGER", u"Minimum retard"),
                                    ("retard_max", "INTEGER", u"Maximum retard"),
                                    ("titre", "VARCHAR(255)", u"Titre du rappel"),
                                    ("texte_xml", "VARCHAR(5000)", u"Contenu du texte version XML"),
                                    ("texte_pdf", "VARCHAR(5000)", u"Contenu du texte version PDF"),
                                    ], # Textes pour les lettres de rappel

    "rappels":[                 ("IDrappel", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDrappel"),
                                    ("numero", "INTEGER", u"Numro du rappel"),
                                    ("IDcompte_payeur", "INTEGER", u"ID du compte payeur"),
                                    ("date_edition", "DATE", u"Date d'dition du rappel"),
                                    ("activites", "VARCHAR(500)", u"Liste des IDactivit spares par ;"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a cr le rappel"),
                                    ("IDtexte", "INTEGER", u"ID du texte de rappel"),
                                    ("date_reference", "DATE", u"Date de rfrence"),
                                    ("solde", "FLOAT", u"Solde  rgler"),
                                    ("date_min", "DATE", u"Date min"),
                                    ("date_max", "DATE", u"Date max"),
                                    ("IDlot", "INTEGER", u"ID du lot de rappels"),
                                    ("prestations", "VARCHAR(500)", u"Liste des types de prestations intgres"),
                                    ], # Rappels dits

    "utilisateurs":[            ("IDutilisateur", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDutilisateur"),
                                    ("sexe", "VARCHAR(5)", u"Sexe de l'utilisateur"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'utilisateur"),
                                    ("prenom", "VARCHAR(200)", u"Prnom de l'utilisateur"),
                                    ("mdp", "VARCHAR(100)", u"Mot de passe"),
                                    ("profil", "VARCHAR(100)", u"Profil (Administrateur ou utilisateur)"),
                                    ("actif", "INTEGER", u"Utilisateur actif"),
                                    ("image", "VARCHAR(200)", u"Images"),
                                    ("mdpcrypt", "VARCHAR(200)", u"Mot de passe crypt"),
                                    ], # Utilisateurs

    "messages":[            ("IDmessage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmessage"),
                                    ("type", "VARCHAR(30)", u"Type (instantan ou programm)"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie"),
                                    ("date_saisie", "DATE", u"Date de saisie"),
                                    ("IDutilisateur", "INTEGER", u"ID de l'utilisateur"),
                                    ("date_parution", "DATE", u"Date de parution"),
                                    ("priorite", "VARCHAR(30)", u"Priorit"),
                                    ("afficher_accueil", "INTEGER", u"Afficher sur la page d'accueil"),
                                    ("afficher_liste", "INTEGER", u"Afficher sur la liste des conso"),
                                    ("rappel", "INTEGER", u"Rappel  l'ouverture du fichier"),
                                    ("IDfamille", "INTEGER", u"IDfamille"),
                                    ("IDindividu", "INTEGER", u"IDindividu"),
                                    ("nom", "VARCHAR(255)", u"Nom de la famille ou de l'individu"),
                                    ("texte", "VARCHAR(500)", u"Texte du message"),
                                    ("afficher_facture", "INTEGER", u"Afficher sur les factures de la famille"),
                                    ], # Messages

    "messages_categories":[("IDcategorie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDcategorie"),
                                    ("nom", "VARCHAR(255)", u"Nom de la catgorie"),
                                    ("priorite", "VARCHAR(30)", u"Priorit"),
                                    ("afficher_accueil", "INTEGER", u"Afficher sur la page d'accueil"),
                                    ("afficher_liste", "INTEGER", u"Afficher sur la liste des conso"),
                                    ], # Catgories de messages

    "historique":[              ("IDaction", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID de l'action"),
                                    ("date", "DATE", u"Date de l'action"),
                                    ("heure", "DATE", u"Heure de l'action"),
                                    ("IDutilisateur", "INTEGER", u"ID de l'utilisateur"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie d'action"),
                                    ("action", "VARCHAR(500)", u"Action"),
                                    ], # Historique

    "attestations":[           ("IDattestation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDattestation"),
                                    ("numero", "INTEGER", u"Numro d'attestation"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("date_edition", "DATE", u"Date d'dition de l'attestation"),
                                    ("activites", "VARCHAR(450)", u"Liste des IDactivit spares par ;"),
                                    ("individus", "VARCHAR(450)", u"Liste des IDindividus spares par ;"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a cr l'attestation"),
                                    ("date_debut", "DATE", u"Date de dbut de priode"),
                                    ("date_fin", "DATE", u"Date de fin de priode"),
                                    ("total", "FLOAT", u"Montant total de la priode"),
                                    ("regle", "FLOAT", u"Montant rgl pour la priode"),
                                    ("solde", "FLOAT", u"Solde  rgler pour la priode"),
                                    ], # Attestation de prsence dites

    "recus":[                   ("IDrecu", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDrecu"),
                                    ("numero", "INTEGER", u"Numro du recu"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("date_edition", "DATE", u"Date d'dition du recu"),
                                    ("IDutilisateur", "INTEGER", u"Utilisateur qui a cr l'attestation"),
                                    ("IDreglement", "INTEGER", u"ID du rglement"),
                                    ], # Recus de rglements

    "adresses_mail":  [    ("IDadresse", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("adresse", "VARCHAR(200)", u"Adresse de messagerie"),
                                    ("motdepasse", "VARCHAR(200)", u"Mot de passe si SSL"),
                                    ("smtp", "VARCHAR(200)", u"Adresse SMTP"),
                                    ("port", "INTEGER", u"Numro du port"),
                                    ("connexionssl", "INTEGER", u"Connexion ssl (1/0) - N'est plus utilis !"),
                                    ("defaut", "INTEGER", u"Adresse utilise par dfaut (1/0)"),
                                    ("connexionAuthentifiee", "INTEGER", u"Authentification active (1/0)"),
                                    ("startTLS", "INTEGER", u"startTLS activ (1/0)"),
                                    ], # Adresses d'expditeur de mail

    "listes_diffusion":  [    ("IDliste", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("nom", "VARCHAR(200)", u"Nom de la liste de diffusion"),
                                    ], # Listes de diffusion

    "abonnements":    [    ("IDabonnement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDliste", "INTEGER", u"ID de la liste de diffusion"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu abonn"),
                                    ], # Abonnements aux listes de diffusion

    "documents_modeles":[("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("nom", "VARCHAR(200)", u"Nom du modle"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie du modle (ex : facture)"),
                                    ("supprimable", "INTEGER", u"Est supprimable (1/0)"),
                                    ("largeur", "INTEGER", u"Largeur en mm"),
                                    ("hauteur", "INTEGER", u"Hauteur en mm"),
                                    ("observations", "VARCHAR(400)", u"Observations"),
                                    ("IDfond", "INTEGER", u"IDfond du modle"),
                                    ("defaut", "INTEGER", u"Modle utilis par dfaut (1/0)"),
                                    ], # Modles de documents

    "documents_objets":[ ("IDobjet", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDmodele", "INTEGER", u"ID du modle rattach"),
                                    ("nom", "VARCHAR(200)", u"Nom de l'objet"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie d'objet (ex : rectangle)"),
                                    ("champ", "VARCHAR(200)", u"Champ"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("obligatoire", "INTEGER", u"Est obligatoire (0/1)"),
                                    ("nbreMax", "INTEGER", u"Nbre max d'objets dans le document"),
                                    ("texte", "VARCHAR(600)", u"Texte"),
                                    ("points", "VARCHAR(600)", u"Points de lignes ou de polygones"),
                                    ("image", "LONGBLOB", u"Image"),
                                    ("typeImage", "VARCHAR(100)", u"Type de l'image (logo, fichier)"),
                                    ("x", "INTEGER", u"Position x"),
                                    ("y", "INTEGER", u"Position y"),
                                    ("verrouillageX", "INTEGER", u"Verrouillage X (0/1)"),
                                    ("verrouillageY", "INTEGER", u"Verrouillage Y (0/1)"),
                                    ("Xmodifiable", "INTEGER", u"Position X est modifiable (0/1)"),
                                    ("Ymodifiable", "INTEGER", u"Position Y est modifiable (0/1)"),
                                    ("largeur", "INTEGER", u"Largeur de l'objet"),
                                    ("hauteur", "INTEGER", u"Hauteur de l'objet"),
                                    ("largeurModifiable", "INTEGER", u"Largeur modifiable (0/1)"),
                                    ("hauteurModifiable", "INTEGER", u"Hauteur modifiable (0/1)"),
                                    ("largeurMin", "INTEGER", u"Largeur min"),
                                    ("largeurMax", "INTEGER", u"Largeur max"),
                                    ("hauteurMin", "INTEGER", u"Hauteur min"),
                                    ("hauteurMax", "INTEGER", u"Hauteur max"),
                                    ("verrouillageLargeur", "INTEGER", u"Hauteur verrouille (0/1)"),
                                    ("verrouillageHauteur", "INTEGER", u"Hauteur verrouille (0/1)"),
                                    ("verrouillageProportions", "INTEGER", u"Proportion verrouille (0/1)"),
                                    ("interditModifProportions", "INTEGER", u"Modification proportions interdite (0/1)"),
                                    ("couleurTrait", "VARCHAR(100)", u"Couleur du trait"),
                                    ("styleTrait", "VARCHAR(100)", u"Style du trait"),
                                    ("epaissTrait", "FLOAT", u"Epaisseur du trait"),
                                    ("coulRemplis", "VARCHAR(100)", u"Couleur du remplissage"),
                                    ("styleRemplis", "VARCHAR(100)", u"Style du remplissage"),
                                    ("couleurTexte", "VARCHAR(100)", u"Couleur du texte"),
                                    ("couleurFond", "VARCHAR(100)", u"Couleur du fond"),
                                    ("padding", "FLOAT", u"Padding du texte"),
                                    ("interligne", "FLOAT", u"Interligne"),
                                    ("taillePolice", "INTEGER", u"Taille de la police"),
                                    ("nomPolice", "VARCHAR(100)", u"Nom de la police"),
                                    ("familyPolice", "INTEGER", u"Famille de la police"),
                                    ("stylePolice", "INTEGER", u"Style de la police"),
                                    ("weightPolice", "INTEGER", u"weight de la police"),
                                    ("soulignePolice", "INTEGER", u"Texte soulign (0/1)"),
                                    ("alignement", "VARCHAR(100)", u"Alignement du texte"),
                                    ("largeurTexte", "INTEGER", u"Largeur du bloc de texte"),
                                    ("norme", "VARCHAR(100)", u"Norme code-barres"),
                                    ("afficheNumero", "INTEGER", u"Affiche numro code-barres"),
                                    ], # Objets des modles de documents

    "questionnaire_categories": [("IDcategorie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("visible", "INTEGER", u"Visible (0/1)"),
                                    ("type", "VARCHAR(100)", u"Individu ou Famille"),
                                    ("couleur", "VARCHAR(100)", u"Couleur de la catgorie"),
                                    ("label", "VARCHAR(400)", u"Label de la question"),
                                    ], # Catgories des questionnaires

    "questionnaire_questions": [("IDquestion", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("visible", "INTEGER", u"Visible (0/1)"),
                                    ("label", "VARCHAR(400)", u"Label de la question"),
                                    ("controle", "VARCHAR(200)", u"Nom du contrle"),
                                    ("defaut", "VARCHAR(400)", u"Valeur par dfaut"),
                                    ("options", "VARCHAR(400)", u"Options de la question"),
                                    ], # Questions des questionnaires

    "questionnaire_choix": [("IDchoix", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDquestion", "INTEGER", u"ID de la question rattache"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("visible", "INTEGER", u"Visible (0/1)"),
                                    ("label", "VARCHAR(400)", u"Label de la question"),
                                    ], # Choix de rponses des questionnaires

    "questionnaire_reponses": [("IDreponse", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDquestion", "INTEGER", u"ID de la question rattache"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu rattach"),
                                    ("IDfamille", "INTEGER", u"ID de la famille rattache"),
                                    ("reponse", "VARCHAR(400)", u"Rponse"),
                                    ], # Rponses des questionnaires

    "questionnaire_filtres": [("IDfiltre", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("IDquestion", "INTEGER", u"ID de la question rattache"),
                                    ("categorie", "VARCHAR(100)", u"Catgorie (ex: 'TARIF')"),
                                    ("choix", "VARCHAR(400)", u"Choix (ex : 'EGAL'"),
                                    ("criteres", "VARCHAR(600)", u"Criteres (ex : '4;5')"),
                                    ("IDtarif", "INTEGER", u"IDtarif rattach"),
                                    ], # Filtres des questionnaires

    "niveaux_scolaires":  [("IDniveau", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("nom", "VARCHAR(400)", u"Nom du niveau (ex : Cours prparatoire)"),
                                    ("abrege", "VARCHAR(200)", u"Abrg du niveau (ex : CP)"),
                                    ], # Niveaux scolaires

    "ecoles":[                  ("IDecole", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Ecole"),
                                    ("nom", "VARCHAR(300)", u"Nom du restaurateur"),
                                    ("rue", "VARCHAR(200)", u"Adresse"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(200)", u"Ville"),  
                                    ("tel", "VARCHAR(50)", u"Tel"),  
                                    ("fax", "VARCHAR(50)", u"Fax"),  
                                    ("mail", "VARCHAR(100)", u"Email"),  
                                    ("secteurs", "VARCHAR(200)", u"Liste des IDsecteur"),  
                                    ], # Ecoles

    "classes":[                ("IDclasse", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Classe"),
                                    ("IDecole", "INTEGER", u"ID de l'cole"),
                                    ("nom", "VARCHAR(400)", u"Nom de la classe"),
                                    ("date_debut", "DATE", u"Date de dbut de priode"),
                                    ("date_fin", "DATE", u"Date de fin de priode"),
                                    ("niveaux", "VARCHAR(300)", u"Liste des niveaux scolaires de la classe"),  
                                    ], # Classes

    "scolarite":[               ("IDscolarite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Scolarite"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("date_debut", "DATE", u"Date de dbut de scolarit"),
                                    ("date_fin", "DATE", u"Date de fin de scolarit"),
                                    ("IDecole", "INTEGER", u"ID de l'cole"),
                                    ("IDclasse", "INTEGER", u"ID de la classe"),
                                    ("IDniveau", "INTEGER", u"ID du niveau scolaire"),
                                    ], # Scolarit

    "transports_compagnies":[("IDcompagnie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Compagnie"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie de la compagnie (taxi,train,avion,etc...)"),
                                    ("nom", "VARCHAR(300)", u"Nom de la compagnie"),
                                    ("rue", "VARCHAR(200)", u"Rue"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(200)", u"Ville"),  
                                    ("tel", "VARCHAR(50)", u"Tl"),  
                                    ("fax", "VARCHAR(50)", u"Fax"),  
                                    ("mail", "VARCHAR(100)", u"Email"),  
                                    ], # Compagnies de transport

    "transports_lieux":[    ("IDlieu", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Lieu"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie du lieu (gare,aeroport,port,station)"),
                                    ("nom", "VARCHAR(300)", u"Nom du lieu"),
                                    ("cp", "VARCHAR(10)", u"Code postal"),
                                    ("ville", "VARCHAR(200)", u"Ville"),  
                                    ], # Lieux pour les transports

    "transports_lignes":[   ("IDligne", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Ligne"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie de la ligne (bus, car, mtro, etc...)"),
                                    ("nom", "VARCHAR(300)", u"Nom de la ligne"),
                                    ], # Lignes rgulires pour les transports

    "transports_arrets":[   ("IDarret", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Arrt"),
                                    ("IDligne", "INTEGER", u"ID de la ligne"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("nom", "VARCHAR(300)", u"Nom de l'arrt"),
                                    ], # Arrts des lignes rgulires pour les transports

    "transports":[            ("IDtransport", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Transport"),
                                    ("IDindividu", "INTEGER", u"ID Individu"),
                                    ("mode", "VARCHAR(100)", u"Mode : TRANSP | PROG | MODELE"),
                                    ("categorie", "VARCHAR(100)", u"Catgorie du moyen de locomotion"),
                                    ("IDcompagnie", "INTEGER", u"ID Compagnie"),
                                    ("IDligne", "INTEGER", u"ID Ligne"),
                                    ("numero", "VARCHAR(200)", u"Numro du vol ou du train"),
                                    ("details", "VARCHAR(300)", u"Dtails"),
                                    ("observations", "VARCHAR(400)", u"Observations"),
                                    ("depart_date", "DATE", u"Date du dpart"),
                                    ("depart_heure", "DATE", u"Heure du dpart"),
                                    ("depart_IDarret", "INTEGER", u"ID Arrt du dpart"),
                                    ("depart_IDlieu", "INTEGER", u"ID Lieu du dpart"),
                                    ("depart_localisation", "VARCHAR(400)", u"Localisation du dpart"),
                                    ("arrivee_date", "DATE", u"Date de l'arrive"),
                                    ("arrivee_heure", "DATE", u"Heure de l'arrive"),
                                    ("arrivee_IDarret", "INTEGER", u"ID Arrt de l'arrive"),
                                    ("arrivee_IDlieu", "INTEGER", u"ID Lieu de l'arrive"),
                                    ("arrivee_localisation", "VARCHAR(400)", u"Localisation de l'arrive"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ("actif", "INTEGER", u"Actif (1/0)"),
                                    ("jours_scolaires", "VARCHAR(100)", u"Jours scolaires"),
                                    ("jours_vacances", "VARCHAR(100)", u"Jours de vacances"),
                                    ("unites", "VARCHAR(480)", u"Liste des units de conso rattaches"),
                                    ("prog", "INTEGER", u"IDtransport du modle de programmation"),
                                    ], # Transports

    "etat_nomin_champs":[("IDchamp", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Champ"),
                                    ("code", "VARCHAR(300)", u"Code du champ"),
                                    ("label", "VARCHAR(400)", u"Nom du champ"),
                                    ("formule", "VARCHAR(450)", u"Formule"),
                                    ("titre", "VARCHAR(400)", u"Titre"),
                                    ], # Champs personnaliss pour Etat Caisse nominatif

    "etat_nomin_selections":[("IDselection", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Slection"),
                                    ("IDprofil", "VARCHAR(400)", u"Nom de profil"),
                                    ("code", "VARCHAR(300)", u"Code du champ"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ], # Slection des Champs personnaliss pour Etat Nominatif

    "etat_nomin_profils":[("IDprofil", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Profil"),
                                    ("label", "VARCHAR(400)", u"Nom de profil"),
                                    ], # Profils pour Etat Caisse nominatif

    "badgeage_actions":   [("IDaction", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Action"),
                                    ("IDprocedure", "INTEGER", u"IDprocedure"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("condition_activite", "VARCHAR(400)", u"Activit"),
                                    ("condition_heure", "VARCHAR(400)", u"Heure"),
                                    ("condition_periode", "VARCHAR(400)", u"Priode"),
                                    ("condition_poste", "VARCHAR(400)", u"Poste rseau"),
                                    ("condition_questionnaire", "VARCHAR(490)", u"Questionnaire"),
                                    ("action", "VARCHAR(400)", u"Code de l'action"),
                                    ("action_activite", "VARCHAR(450)", u"Activit"),
                                    ("action_unite", "VARCHAR(450)", u"Units"),
                                    ("action_etat", "VARCHAR(400)", u"Etat de la conso"),
                                    ("action_demande", "VARCHAR(40)", u"Demande si dbut ou fin"),
                                    ("action_heure_debut", "VARCHAR(450)", u"Heure de dbut"),
                                    ("action_heure_fin", "VARCHAR(450)", u"Heure de fin"),
                                    ("action_message", "VARCHAR(450)", u"Message unique"),
                                    ("action_icone", "VARCHAR(400)", u"Icone pour boite de dialogue"),
                                    ("action_duree", "VARCHAR(50)", u"Dure d'affichage du message"),
                                    ("action_frequence", "VARCHAR(450)", u"Frequence diffusion message"),
                                    ("action_vocal", "VARCHAR(400)", u"Synthese vocale activation"),
                                    ("action_question", "VARCHAR(450)", u"Question"),
                                    ("action_date", "VARCHAR(450)", u"Date  proposer"),
                                    ("action_attente", "VARCHAR(450)", u"Proposer attente"),
                                    ("action_ticket", "VARCHAR(450)", u"Impression_ticket"),
                                    ], # Badgeage : Actions

    "badgeage_messages":[("IDmessage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Message"),
                                    ("IDprocedure", "INTEGER", u"IDprocedure"),
                                    ("IDaction", "INTEGER", u"IDaction rattache"),
                                    ("message", "VARCHAR(480)", u"Texte du message"),
                                    ], # Badgeage : Messages pour Actions

    "badgeage_procedures":[("IDprocedure", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Procdure"),
                                    ("nom", "VARCHAR(450)", u"Nom"),
                                    ("defaut", "INTEGER", u"Dfaut (0/1)"),
                                    ("style", "VARCHAR(400)", u"Style interface"),
                                    ("theme", "VARCHAR(400)", u"Thme interface"),
                                    ("image", "VARCHAR(400)", u"Image personnalise pour thme"),
                                    ("systeme", "VARCHAR(400)", u"Systme de saisie"),
                                    ("activites", "VARCHAR(400)", u"Liste ID activites pour saisie par liste d'individus"),
                                    ("confirmation", "INTEGER", u"Confirmation identification (0/1)"),
                                    ("vocal", "INTEGER", u"Activation synthse vocale (0/1)"),
                                    ("tutoiement", "INTEGER", u"Activation du tutoiement dans les messages (0/1)"),
                                    ], #  Badgeage : Procdures

    "badgeage_journal":[ ("IDaction", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Action"),
                                    ("date", "DATE", u"Date de l'action"),
                                    ("heure", "VARCHAR(50)", u"Heure"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("individu", "VARCHAR(450)", u"Nom de l'individu"),
                                    ("action", "VARCHAR(450)", u"Action ralise"),
                                    ("resultat", "VARCHAR(450)", u"Rsultat de l'action"),
                                    ], #  Badgeage : Journal

    "badgeage_archives":[ ("IDarchive", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Archive"),
                                    ("date_archivage", "DATE", u"Date de l'archivage"),
                                    ("codebarres", "VARCHAR(200)", u"Code-barres"),
                                    ("date", "DATE", u"Date badge"),
                                    ("heure", "VARCHAR(50)", u"Heure badge"),
                                    ], #  Badgeage : Archives des importations

    "corrections_phoniques":[("IDcorrection", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Correction"),
                                    ("mot", "VARCHAR(400)", u"Mot  corriger"),
                                    ("correction", "VARCHAR(400)", u"Correction phonique"),
                                    ], # Corrections phoniques pour la synthse vocale

    "corrections_villes":[("IDcorrection", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Correction"),
                                    ("mode", "VARCHAR(100)", u"Mode de correction"),
                                    ("IDville", "INTEGER", u"ID ville"),
                                    ("nom", "VARCHAR(450)", u"Nom de la ville"),
                                    ("cp", "VARCHAR(100)", u"Code postal"),
                                    ], # Personnalisation des villes et codes postaux

    "modeles_emails":[ ("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmodele"),
                                    ("categorie", "VARCHAR(455)", u"Catgorie du modle"),
                                    ("nom", "VARCHAR(455)", u"Nom du modle"),
                                    ("description", "VARCHAR(455)", u"Description du modle"),
                                    ("objet", "VARCHAR(455)", u"Texte objet du mail"),
                                    ("texte_xml", "VARCHAR(50000)", u"Contenu du texte version XML"),
                                    ("IDadresse", "INTEGER", u"IDadresse d'expdition de mails"),
                                    ("defaut", "INTEGER", u"Modle par dfaut (0/1)"),
                                    ], # Modles d'Emails

    "banques":[                ("IDbanque", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID de la banque"),
                                    ("nom", "VARCHAR(100)", u"Nom de la banque"),
                                    ("rue_resid", "VARCHAR(255)", u"Adresse de la banque"),
                                    ("cp_resid", "VARCHAR(10)", u"Code postal de la banque"),
                                    ("ville_resid", "VARCHAR(100)", u"Ville de la banque"),  
                                    ], # Les tablissements bancaires pour le prlvement automatique

    "lots_factures":[         ("IDlot", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID lot de factures"),
                                    ("nom", "VARCHAR(400)", u"Nom du lot"),
                                    ], # Lots de factures

    "lots_rappels":[         ("IDlot", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID lot de rappels"),
                                    ("nom", "VARCHAR(400)", u"Nom du lot"),
                                    ], # Lots de rappels

    "prelevements":[         ("IDprelevement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID prlvement"),
                                    ("IDlot", "INTEGER", u"ID du lot de prlvements"),
                                    ("IDfamille", "INTEGER", u"ID de la famille destinataire"),
                                    ("prelevement_etab", "VARCHAR(50)", u"Prlvement - Code tab"),
                                    ("prelevement_guichet", "VARCHAR(50)", u"Prlvement - Code guichet"),
                                    ("prelevement_numero", "VARCHAR(50)", u"Prlvement - Numro de compte"),
                                    ("prelevement_banque", "INTEGER", u"Prlvement - ID de la Banque"),
                                    ("prelevement_cle", "VARCHAR(50)", u"Prlvement - Code cl"),
                                    ("prelevement_iban", "VARCHAR(100)", u"Prlvement - Cl IBAN"),
                                    ("prelevement_bic", "VARCHAR(100)", u"Prlvement - BIC"),
                                    ("prelevement_reference_mandat", "VARCHAR(300)", u"Prlvement - Rfrence mandat"),
                                    ("prelevement_date_mandat", "DATE", u"Prlvement - Date mandat"),
                                    ("titulaire", "VARCHAR(400)", u"Titulaire du compte"),
                                    ("type", "VARCHAR(400)", u"Type du prlvement"),
                                    ("IDfacture", "INTEGER", u"ID de la facture"),
                                    ("libelle", "VARCHAR(400)", u"Libell du prlvement"),
                                    ("montant", "FLOAT", u"Montant du prlvement"),
                                    ("statut", "VARCHAR(100)", u"Statut du prlvement"),
                                    ("IDmandat", "INTEGER", u"ID du mandat"),
                                    ("sequence", "VARCHAR(100)", u"Squence SEPA"),
                                    ], # Prlvement

    "lots_prelevements":[  ("IDlot", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du lot de prlvement"),
                                    ("nom", "VARCHAR(200)", u"Nom du lot de prlvements"),
                                    ("date", "DATE", u"Date du prlvement"),
                                    ("verrouillage", "INTEGER", u"(0/1) Verrouillage du lot"),
                                    ("IDcompte", "INTEGER", u"ID du compte crditeur"),
                                    ("IDmode", "INTEGER", u"ID du mode de rglement"),
                                    ("reglement_auto", "INTEGER", u"Rglement automatique (0/1)"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("type", "VARCHAR(100)", u"Type (national ou SEPA)"),
                                    ], # Lots de prlvements

    "modeles_tickets":[ ("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmodele"),
                                    ("categorie", "VARCHAR(455)", u"Catgorie du modle"),
                                    ("nom", "VARCHAR(455)", u"Nom du modle"),
                                    ("description", "VARCHAR(455)", u"Description du modle"),
                                    ("lignes", "VARCHAR(5000)", u"lignes du ticket"),
                                    ("defaut", "INTEGER", u"Modle par dfaut (0/1)"),
                                    ("taille", "INTEGER", u"Taille de police"),
                                    ("interligne", "INTEGER", u"Hauteur d'interligne"),
                                    ("imprimante", "VARCHAR(455)", u"Nom de l'imprimante"),
                                    ], # Modles de tickets

    "sauvegardes_auto":[ ("IDsauvegarde", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDsauvegarde"),
                                    ("nom", "VARCHAR(455)", u"Nom de la procdure de sauvegarde auto"),
                                    ("observations", "VARCHAR(455)", u"Observations"),
                                    ("date_derniere", "DATE", u"Date de la dernire sauvegarde"),
                                    ("sauvegarde_nom", "VARCHAR(455)", u"Sauvegarde Nom"),
                                    ("sauvegarde_motdepasse", "VARCHAR(455)", u"Sauvegarde mot de passe"),
                                    ("sauvegarde_repertoire", "VARCHAR(455)", u"sauvegarde Rpertoire"),
                                    ("sauvegarde_emails", "VARCHAR(455)", u"Sauvegarde Emails"),
                                    ("sauvegarde_fichiers_locaux", "VARCHAR(455)", u"Sauvegarde fichiers locaux"),
                                    ("sauvegarde_fichiers_reseau", "VARCHAR(455)", u"Sauvegarde fichiers rseau"),
                                    ("condition_jours_scolaires", "VARCHAR(455)", u"Condition Jours scolaires"),
                                    ("condition_jours_vacances", "VARCHAR(455)", u"Condition Jours vacances"),
                                    ("condition_heure", "VARCHAR(455)", u"Condition Heure"),
                                    ("condition_poste", "VARCHAR(455)", u"Condition Poste"),
                                    ("condition_derniere", "VARCHAR(455)", u"Condition Date dernire sauvegarde"),
                                    ("condition_utilisateur", "VARCHAR(455)", u"Condition Utilisateur"),
                                    ("option_afficher_interface", "VARCHAR(455)", u"Option Afficher interface (0/1)"),
                                    ("option_demander", "VARCHAR(455)", u"Option Demander (0/1)"),
                                    ("option_confirmation", "VARCHAR(455)", u"Option Confirmation (0/1)"),
                                    ("option_suppression", "VARCHAR(455)", u"Option Suppression sauvegardes obsoltes"),
                                    ], # procdures de sauvegardes automatiques

    "droits":[                   ("IDdroit", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDdroit"),
                                    ("IDutilisateur", "INTEGER", u"IDutilisateur"),
                                    ("IDmodele", "INTEGER", u"IDmodele"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie de droits"),
                                    ("action", "VARCHAR(200)", u"Type d'action"),
                                    ("etat", "VARCHAR(455)", u"Etat"),
                                    ], # Droits des utilisateurs

    "modeles_droits":[     ("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmodele"),
                                    ("nom", "VARCHAR(455)", u"Nom du modle"),
                                    ("observations", "VARCHAR(455)", u"Observations"),
                                    ("defaut", "INTEGER", u"Modle par dfaut (0/1)"),
                                    ], # Modles de droits

    "mandats":[               ("IDmandat", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmandat"),
                                    ("IDfamille", "INTEGER", u"Famille rattache"),
                                    ("rum", "VARCHAR(100)", u"RUM du mandat"),
                                    ("type", "VARCHAR(100)", u"Type de mandat (rcurrent ou ponctuel)"),
                                    ("date", "DATE", u"Date de signature du mandat"),
                                    ("IDbanque", "INTEGER", u"ID de la banque"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("individu_nom", "VARCHAR(400)", u"Nom du titulaire de compte"),
                                    ("individu_rue", "VARCHAR(400)", u"Rue du titulaire de compte"),
                                    ("individu_cp", "VARCHAR(50)", u"CP du titulaire de compte"),
                                    ("individu_ville", "VARCHAR(400)", u"Ville du titulaire de compte"),
                                    ("iban", "VARCHAR(100)", u"IBAN"),
                                    ("bic", "VARCHAR(100)", u"BIC"),
                                    ("memo", "VARCHAR(450)", u"Mmo"),
                                    ("sequence", "VARCHAR(100)", u"Prochaine squence"),
                                    ("actif", "INTEGER", u"actif (0/1)"),
                                    ], # Mandats SEPA

    "pes_pieces":[           ("IDpiece", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID piece"),
                                    ("IDlot", "INTEGER", u"ID du lot PES"),
                                    ("IDfamille", "INTEGER", u"ID de la famille destinataire"),
                                    ("prelevement", "INTEGER", u"Prlvement activ (0/1)"),
                                    ("prelevement_iban", "VARCHAR(100)", u"IBAN"),
                                    ("prelevement_bic", "VARCHAR(100)", u"BIC"),
                                    ("prelevement_rum", "VARCHAR(300)", u"Rfrence Unique Mandat"),
                                    ("prelevement_date_mandat", "DATE", u"Date mandat"),
                                    ("prelevement_IDmandat", "INTEGER", u"ID du mandat"),
                                    ("prelevement_sequence", "VARCHAR(100)", u"Squence SEPA"),
                                    ("prelevement_titulaire", "VARCHAR(400)", u"Titulaire du compte bancaire"),
                                    ("prelevement_statut", "VARCHAR(100)", u"Statut du prlvement"),
                                    ("titulaire_helios", "INTEGER", u"Tiers Trsor public"),
                                    ("type", "VARCHAR(400)", u"Type du prlvement"),
                                    ("IDfacture", "INTEGER", u"ID de la facture"),
                                    ("numero", "INTEGER", u"Numro de facture"),
                                    ("libelle", "VARCHAR(400)", u"Libell de la pice"),
                                    ("montant", "FLOAT", u"Montant du prlvement"),
                                    ], # Pices PESV2 ORMC

    "pes_lots":[               ("IDlot", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du lot"),
                                    ("nom", "VARCHAR(200)", u"Nom du lot"),
                                    ("verrouillage", "INTEGER", u"(0/1) Verrouillage du lot"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("reglement_auto", "INTEGER", u"Rglement automatique (0/1)"),
                                    ("IDcompte", "INTEGER", u"ID du compte crditeur"),
                                    ("IDmode", "INTEGER", u"ID du mode de rglement"),
                                    ("exercice", "INTEGER", u"Exercice"),
                                    ("mois", "INTEGER", u"Numro de mois"),
                                    ("objet_dette", "VARCHAR(450)", u"Objet de la dette"),
                                    ("date_emission", "DATE", u"Date d'mission"),
                                    ("date_prelevement", "DATE", u"Date du prlvement"),
                                    ("date_envoi", "DATE", u"Date d'avis d'envoi"),
                                    ("id_bordereau", "VARCHAR(200)", u"Identifiant bordereau"),
                                    ("id_poste", "VARCHAR(200)", u"Poste comptable"),
                                    ("id_collectivite", "VARCHAR(200)", u"ID budget collectivit"),
                                    ("code_collectivite", "VARCHAR(200)", u"Code Collectivit"),
                                    ("code_budget", "VARCHAR(200)", u"Code Budget"),
                                    ("code_prodloc", "VARCHAR(200)", u"Code Produit Local"),
                                    ("prelevement_libelle", "VARCHAR(450)", u"Libell du prlvement"),
                                    ("objet_piece", "VARCHAR(450)", u"Objet de la pice"),
                                    ], # Lots PESV2 ORMC

    "contrats":[               ("IDcontrat", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID contrat"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("IDinscription", "INTEGER", u"ID de l'inscription"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("type", "VARCHAR(100)", u"Type de contrat"),
                                    ("nbre_absences_prevues", "INTEGER", u"Nombre d'absences prvues PSU"),
                                    ("nbre_heures_regularisation", "INTEGER", u"Nombre d'heures de rgularisation PSU"),
                                    ("arrondi_type", "VARCHAR(50)", u"Type d'arrondi sur les heures"),
                                    ("arrondi_delta", "INTEGER", u"Delta en minutes de l'arrondi sur les heures"),
                                    ("duree_absences_prevues", "VARCHAR(50)", u"Temps d'absences prvues PSU"),
                                    ("duree_heures_regularisation", "VARCHAR(50)", u"Temps de rgularisation PSU"),
                                    ("duree_tolerance_depassement", "VARCHAR(50)", u"Temps de tolrance dpassements PSU"),
                                    ("planning", "VARCHAR(900)", u"Donnes de planning serialises"),
                                    ], # Contrats

    "modeles_contrats":[ ("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID modle"),
                                    ("nom", "VARCHAR(450)", u"Nom du modle"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ("observations", "VARCHAR(500)", u"Observations"),
                                    ("IDtarif", "INTEGER", u"ID du tarif"),
                                    ("donnees", "LONGBLOB", u"Donnes en binaire"),
                                    ], # Modles de contrats

    "modeles_plannings":[("IDmodele", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID modle"),
                                    ("IDactivite", "INTEGER", u"ID de l'activits concerne"),
                                    ("nom", "VARCHAR(450)", u"Nom du modle"),
                                    ("donnees", "VARCHAR(900)", u"Donnes serialises"),
                                    ], # Modles de plannings

    "compta_operations":[("IDoperation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID opration"),
                                    ("type", "VARCHAR(200)", u"Type de donnes (debit/crdit)"),
                                    ("date", "DATE", u"Date de l'opration"),
                                    ("libelle", "VARCHAR(400)", u"Libell de l'opration"),
                                    ("IDtiers", "INTEGER", u"ID du tiers"),
                                    ("IDmode", "INTEGER", u"ID du mode de rglement"),
                                    ("num_piece", "VARCHAR(200)", u"Numro de pice"),
                                    ("ref_piece", "VARCHAR(200)", u"Rfrence de la pice"),
                                    ("IDcompte_bancaire", "INTEGER", u"ID du compte bancaire"),
                                    ("IDreleve", "INTEGER", u"ID du relev bancaire"),
                                    ("montant", "FLOAT", u"Montant de l'opration"),
                                    ("observations", "VARCHAR(450)", u"Observations"),
                                    ("IDvirement", "INTEGER", u"IDvirement associ"),
                                    ], # Compta : Oprations

    "compta_virements":[ ("IDvirement", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID virement"),
                                    ("IDoperation_debit", "INTEGER", u"ID opration dbiteur"),
                                    ("IDoperation_credit", "INTEGER", u"ID opration crditeur"),
                                    ], # Compta : Virements

    "compta_ventilation":[("IDventilation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID ventilation"),
                                    ("IDoperation", "INTEGER", u"ID de l'opration"),
                                    ("IDexercice", "INTEGER", u"ID de l'exercice"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie"),
                                    ("IDanalytique", "INTEGER", u"ID du poste analytique"),
                                    ("libelle", "VARCHAR(400)", u"Libell de la ventilation"),
                                    ("montant", "FLOAT", u"Montant de la ventilation"),
                                    ("date_budget", "DATE", u"Date d'impact budgtaire"),
                                    ], # Compta : Ventilation des oprations
                                    
    "compta_exercices":[("IDexercice", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Exercice"),
                                    ("nom", "VARCHAR(400)", u"Nom de l'exercice"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ("defaut", "INTEGER", u"Dfaut (0/1)"),
                                    ], # Compta : Exercices

    "compta_analytiques":[("IDanalytique", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Analytique"),
                                    ("nom", "VARCHAR(400)", u"Nom du poste analytique"),
                                    ("abrege", "VARCHAR(200)", u"Abrg du poste analytique"),
                                    ("defaut", "INTEGER", u"Dfaut (0/1)"),
                                    ], # Compta : Postes analytiques

    "compta_categories":[("IDcategorie", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Catgorie"),
                                    ("type", "VARCHAR(200)", u"Type de donnes (debit/crdit)"),
                                    ("nom", "VARCHAR(400)", u"Nom de la catgorie"),
                                    ("abrege", "VARCHAR(200)", u"Abrg de la catgorie"),
                                    ("journal", "VARCHAR(200)", u"Code journal"),
                                    ("IDcompte", "INTEGER", u"ID du compte comptable"),
                                    ], # Compta : Catgories de ventilation

    "compta_comptes_comptables":[("IDcompte", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDcompte"),
                                    ("numero", "VARCHAR(200)", u"Numro"),
                                    ("nom", "VARCHAR(400)", u"Nom du code"),
                                    ], # Compta : Comptes comptables

    "compta_tiers":         [("IDtiers", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Tiers"),
                                    ("nom", "VARCHAR(400)", u"Nom du tiers"),
                                    ("observations", "VARCHAR(450)", u"Observations"),
                                    ("IDcode_comptable", "INTEGER", u"ID du code comptable"),
                                    ], # Compta : Tiers

    "compta_budgets":    [("IDbudget", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Budget"),
                                    ("IDexercice", "INTEGER", u"ID de l'exercice"),
                                    ("nom", "VARCHAR(400)", u"Nom du budget"),
                                    ("observations", "VARCHAR(200)", u"Observations sur le budget"),
                                    ("analytiques", "VARCHAR(450)", u"Liste des postes analytiques associs"),
                                    ("date_debut", "DATE", u"Date de dbut de priode"),
                                    ("date_fin", "DATE", u"Date de fin de priode"),
                                    ], # Compta : Budgets

    "compta_categories_budget":[("IDcategorie_budget", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Categorie budget"),
                                    ("IDbudget", "INTEGER", u"ID du budget"),
                                    ("type", "VARCHAR(200)", u"Type de donnes (debit/crdit)"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie rattache"),
                                    ("valeur", "VARCHAR(450)", u"Valeur ou formule"),
                                    ], # Compta : Catgories de budget

    "compta_releves":   [("IDreleve", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Relev"),
                                    ("nom", "VARCHAR(400)", u"Nom du relev"),
                                    ("date_debut", "DATE", u"Date de dbut"),
                                    ("date_fin", "DATE", u"Date de fin"),
                                    ("IDcompte_bancaire", "INTEGER", u"ID du compte bancaire"),
                                    ], # Compta : Relevs de comptes

    "compta_operations_budgetaires":[("IDoperation_budgetaire", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID opration budgtaire"),
                                    ("type", "VARCHAR(200)", u"Type de donnes (debit/crdit)"),
                                    ("date_budget", "DATE", u"Date d'impact budgtaire"),
                                    ("IDcategorie", "INTEGER", u"ID de la catgorie"),
                                    ("IDanalytique", "INTEGER", u"ID du poste analytique"),
                                    ("libelle", "VARCHAR(400)", u"Libell de la ventilation"),
                                    ("montant", "FLOAT", u"Montant de la ventilation"),
                                    ], # Compta : Ventilation des oprations

    "nomade_archivage":  [("IDarchive", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Archive"),
                                    ("nom_fichier", "VARCHAR(400)", u"Nom du fichier"),
                                    ("ID_appareil", "VARCHAR(100)", u"ID de l'appareil"),
                                    ("date", "DATE", u"Date de l'archivage"),
                                    ], # Synchronisation Nomadhys : Archivage des fichiers

    "etiquettes":              [("IDetiquette", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Etiquette"),
                                    ("label", "VARCHAR(300)", u"Label de l'tiquette"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("parent", "INTEGER", u"Parent de l'tiquette"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ("couleur", "VARCHAR(30)", u"Couleur de l'tiquette"),
                                    ("active", "INTEGER", u"Etiquette active (0/1)"),
                                    ], # Etiquettes de consommations

    "contrats_tarifs":              [("IDcontrat_tarif", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID contrat tarif"),
                                    ("IDcontrat", "INTEGER", u"ID du contrat"),
                                    ("date_debut", "DATE", u"Date de dbut de validit"),
                                    ("revenu", "FLOAT", u"Revenu de la famille"),
                                    ("quotient", "INTEGER", u"Quotient familial de la famille"),
                                    ("taux", "FLOAT", u"Taux d'effort"),
                                    ("tarif_base", "FLOAT", u"Montant du tarif de base"),
                                    ("tarif_depassement", "FLOAT", u"Montant du tarif de dpassement"),
                                    ], # Tarifs de contrats

    "types_quotients":              [("IDtype_quotient", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Type quotient"),
                                    ("nom", "VARCHAR(255)", u"Nom du type de quotient"),
                                    ], # Types de quotients

    "factures_prefixes":            [("IDprefixe", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID prfixe facture"),
                                    ("nom", "VARCHAR(450)", u"Nom du prfixe"),
                                    ("prefixe", "VARCHAR(100)", u"Prfixe de facture"),
                                    ], # Prfixes de factures

    "portail_periodes":             [("IDperiode", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID priode"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("nom", "VARCHAR(300)", u"Nom de la priode"),
                                    ("date_debut", "DATE", u"Date de dbut de la priode"),
                                    ("date_fin", "DATE", u"Date de fin de la priode"),
                                    ("affichage", "INTEGER", u"Affich sur le portail (0/1)"),
                                    ("affichage_date_debut", "DATETIME", u"Date et heure de dbut d'affichage"),
                                    ("affichage_date_fin", "DATETIME", u"Date et heure de fin d'affichage"),
                                    ("IDmodele", "INTEGER", u"IDmodele d'email rattach  la priode"),
                                    ("introduction", "VARCHAR(1000)", u"Texte d'introduction"),
                                    ], # Priodes de rservations pour le portail

    "portail_unites":               [("IDunite", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID unit"),
                                    ("IDactivite", "INTEGER", u"ID de l'activit"),
                                    ("nom", "VARCHAR(300)", u"Nom de l'unit de rservation"),
                                    ("unites_principales", "VARCHAR(300)", u"Units de consommation principales"),
                                    ("unites_secondaires", "VARCHAR(300)", u"Units de consommation secondaires"),
                                    ("ordre", "INTEGER", u"Ordre"),
                                    ], # Units de rservations pour le portail

    "portail_actions":              [("IDaction", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID action"),
                                    ("horodatage", "DATETIME", u"Horodatage de l'action"),
                                    ("IDfamille", "INTEGER", u"ID de la famille"),
                                    ("IDindividu", "INTEGER", u"ID de l'individu"),
                                    ("categorie", "VARCHAR(50)", u"Catgorie de l'action"),
                                    ("action", "VARCHAR(50)", u"Nom de l'action"),
                                    ("description", "VARCHAR(300)", u"Description de l'action"),
                                    ("commentaire", "VARCHAR(300)", u"Commentaire de l'action"),
                                    ("parametres", "VARCHAR(300)", u"Paramtres de l'action"),
                                    ("etat", "VARCHAR(50)", u"Etat de l'action"),
                                    ("traitement_date", "DATE", u"Date du traitement de l'action"),
                                    ("IDperiode", "INTEGER", u"ID de la priode"),
                                    ("ref_unique", "VARCHAR(50)", u"Rfrence unique de l'action"),
                                    ("reponse", "VARCHAR(450)", u"Rponse  l'action"),
                                    ("email_date", "DATE", u"Date de l'envoi de l'email de rponse"),
                                    ], # Actions enregistres sur le portail

    "portail_reservations":         [("IDreservation", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID rservation"),
                                    ("date", "DATE", u"Date de la consommation"),
                                    ("IDinscription", "INTEGER", u"ID de l'inscription"),
                                    ("IDunite", "INTEGER", u"ID de l'unit"),
                                    ("IDaction", "INTEGER", u"ID de l'action"),
                                    ("etat", "INTEGER", u"Ajout ou suppression de la rservation (1/0)"),
                                    ], # Rservations enregistres sur le portail

    "portail_messages":             [("IDmessage", "INTEGER PRIMARY KEY AUTOINCREMENT", u"IDmessage"),
                                    ("titre", "VARCHAR(255)", u"Titre du message"),
                                    ("texte", "VARCHAR(1000)", u"Contenu du message"),
                                    ("affichage_date_debut", "DATETIME", u"Date et heure de dbut d'affichage"),
                                    ("affichage_date_fin", "DATETIME", u"Date et heure de fin d'affichage"),
                                     ], # Messages pour la page d'accueil du portail

    "profils":                      [("IDprofil", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID Profil"),
                                    ("label", "VARCHAR(400)", u"Nom de profil"),
                                    ("categorie", "VARCHAR(200)", u"Catgorie du profil"),
                                    ("defaut", "INTEGER", u"(0/1) Profil slectionn par dfaut"),
                                    ],  # Profils de paramtres

    "profils_parametres":           [("IDparametre", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID parametre"),
                                    ("IDprofil", "INTEGER", u"ID du profil"),
                                    ("nom", "VARCHAR(200)", u"Nom"),
                                    ("parametre", "VARCHAR(30000)", u"Parametre"),
                                    ("type_donnee", "VARCHAR(200)", u"Type de donnes"),
                                    ],  # Paramtres des profils

}

# ----------------------------------------------------------------------------------------------------------------------------------------------------------

DB_PHOTOS = {

    "photos":[                  ("IDphoto", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID de la photo"),
                                    ("IDindividu", "INTEGER", u"ID de la personne"),
                                    ("photo", "BLOB", u"Photo individu en binaire"),
                                    ], # BLOB photos
    }

# ----------------------------------------------------------------------------------------------------------------------------------------------------------

DB_DOCUMENTS = {

    "documents":[            ("IDdocument", "INTEGER PRIMARY KEY AUTOINCREMENT", u"ID du document"),
                                    ("IDpiece", "INTEGER", u"ID de la pice"),
                                    ("IDreponse", "INTEGER", u"ID de la rponse du Questionnaire"),
                                    ("IDtype_piece", "INTEGER", u"ID du type de pice"),
                                    ("document", "LONGBLOB", u"Document converti en binaire"),
                                    ("type", "VARCHAR(50)", u"Type de document : jpeg, pdf..."),
                                    ("label", "VARCHAR(400)", u"Label du document"),
                                    ("last_update", "VARCHAR(50)", u"Horodatage de la dernire modification du document"),
                                    ], # BLOB documents
                                    
    }

# ----------------------------------------------------------------------------------------------------------------------------------------------------------

DB_INDEX = {

    "index_photos_IDindividu" : {"table" : "photos", "champ" : "IDindividu"},
    "index_liens_IDfamille" : {"table" : "liens", "champ" : "IDfamille"},
    "index_familles_IDcompte_payeur" : {"table" : "familles", "champ" : "IDcompte_payeur"},
    "index_rattachements_IDfamille" : {"table" : "rattachements", "champ" : "IDfamille"},
    "index_pieces_IDfamille" : {"table" : "pieces", "champ" : "IDfamille"},
    "index_pieces_IDindividu" : {"table" : "pieces", "champ" : "IDindividu"},
    "index_ouvertures_IDactivite" : {"table" : "ouvertures", "champ" : "IDactivite"},
    "index_ouvertures_date" : {"table" : "ouvertures", "champ" : "date"},
    "index_remplissage_IDactivite" : {"table" : "remplissage", "champ" : "IDactivite"},
    "index_remplissage_date" : {"table" : "remplissage", "champ" : "date"},
    "index_inscriptions_IDindividu" : {"table" : "inscriptions", "champ" : "IDindividu"},
    "index_inscriptions_IDfamille" : {"table" : "inscriptions", "champ" : "IDfamille"},
    "index_consommations_IDcompte_payeur" : {"table" : "consommations", "champ" : "IDcompte_payeur"},
    "index_consommations_IDindividu" : {"table" : "consommations", "champ" : "IDindividu"},
    "index_consommations_IDactivite" : {"table" : "consommations", "champ" : "IDactivite"},
    "index_consommations_date" : {"table" : "consommations", "champ" : "date"},
    "index_prestations_IDfamille" : {"table" : "prestations", "champ" : "IDfamille"},
    "index_prestations_IDcompte_payeur" : {"table" : "prestations", "champ" : "IDcompte_payeur"},
    "index_prestations_date" : {"table" : "prestations", "champ" : "date"},
    "index_prestations_IDactivite" : {"table" : "prestations", "champ" : "IDactivite"},
    "index_comptes_payeurs_IDfamille" : {"table" : "comptes_payeurs", "champ" : "IDfamille"},
    "index_reglements_IDcompte_payeur" : {"table" : "reglements", "champ" : "IDcompte_payeur"},
    "index_ventilation_IDcompte_payeur" : {"table" : "ventilation", "champ" : "IDcompte_payeur"},
    "index_ventilation_IDprestation" : {"table" : "ventilation", "champ" : "IDprestation"},
    "index_factures_IDcompte_payeur" : {"table" : "factures", "champ" : "IDcompte_payeur"},

    }






if __name__ == "__main__":
    """ Affichage de stats sur les tables """
    nbreChamps = 0
    for nomTable, listeChamps in DB_DATA.iteritems() :
        nbreChamps += len(listeChamps)
    print "Nbre de champs DATA =", nbreChamps
    print "Nbre de tables DATA =", len(DB_DATA.keys())